#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\AstrayFX\BloomingHDR.fx"
#line 106
uniform int Auto_Bloom <
ui_type = "combo";
ui_label = "Auto Bloom";
ui_items = "Off\0Auto Intensity\0Auto Desaturation\0Auto Saturation\0Auto Intensity & Desaturation\0Auto Intensity & Saturation\0";
ui_tooltip = "Auto Intensity will enable the shader to adjust Bloom Intensity automaticly though Bloom Opacity above.\n"
"Auto Saturation will enable the shader to adjust Bloom Saturation automaticly though Bloom Saturation above.\n"
"Default is Off.";
ui_category = "Bloom Adjustments";
> = 0;
#line 116
uniform float CBT_Adjust <
#line 121
ui_type = "slider";
#line 123
ui_min = 0.0; ui_max = 1.0;
ui_label = "Extracting Bright Colors";
ui_tooltip = "Use this to set the color based brightness threshold for what is and what isn't allowed.\n"
"This is the most important setting, use Debug View to adjust this.\n"
"Default Number is 0.5.";
ui_category = "Bloom Adjustments";
> = 0.5;
#line 143
uniform float2 Bloom_Intensity<
#line 147
ui_type = "slider";
#line 149
ui_min = 0.0; ui_max = 1.0;
ui_label = "Bloom Intensity & Bloom Opacity";
ui_tooltip = "Use this to set Primary & Secondary Bloom Intensity and Overall Bloom Opacity for your content.\n"
#line 153
"Number 0.1 & 0.5 is default.";
ui_category = "Bloom Adjustments";
> = float2(0.1,0.5);
#line 157
uniform float BloomSensitivity <
#line 161
ui_type = "slider";
#line 163
ui_min      = 0.1; ui_max      = 5.0;
ui_label    = "Bloom Sensitivity";
ui_tooltip  = "A Curve that is applied to the bloom input.";
ui_category = "Bloom Adjustments";
> = 1.0;
#line 169
uniform float BloomCurve <
#line 173
ui_type = "slider";
#line 175
ui_min      = 0.1; ui_max      = 5.0;
ui_label    = "Bloom Curve";
ui_tooltip  = "Defines the way the bloom spreads.";
ui_category = "Bloom Adjustments";
> = 2.0;
#line 181
uniform float2 Saturation <
#line 185
ui_type = "slider";
#line 187
ui_min = 0.0; ui_max = 1.0;
ui_label = "Bloom Saturation & Auto Cutoff Point";
ui_tooltip = "Adjustment The amount to adjust the saturation of the Bloom.\n"
"Number 0.25 is default for both.";
ui_category = "Bloom Adjustments";
> = float2(0.25,0.25);
#line 194
uniform float Bloom_Spread <
#line 198
ui_type = "slider";
#line 200
ui_min = 0.5; ui_max = 5.0;
ui_label = "Bloom Spread";
ui_tooltip = "Adjust to spread out the primary Bloom.\n"
"This is used for spreading Bloom.\n"
"Number 1.0 is default.";
ui_category = "Bloom Adjustments";
> = 1.0;
#line 208
uniform float Dither_Bloom <
ui_type = "slider";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Bloom Dither";
ui_tooltip = "Adjustment The amount Dither on bloom to reduce banding.\n"
"Number 0.25 is default.";
ui_category = "Bloom Adjustments";
> = 0.125;
#line 217
uniform int Tonemappers <
ui_type = "combo";
ui_label = "Tonemappers";
ui_tooltip = "Changes how color get used for the other effects.\n";
ui_items = "Timothy\0ACESFitted\0";
ui_category = "Tonemapper Adjustments";
> = 0;
#line 225
uniform float WP <
ui_type = "drag";
ui_min = 0.00; ui_max = 2.00;
ui_label = "Linear White Point Value";
ui_category = "Tonemapper Adjustments";
> = 1.0;
#line 232
uniform float Exp <
ui_type = "drag";
ui_min = -4.0; ui_max = 4.00;
ui_label = "Exposure";
ui_category = "Tonemapper Adjustments";
> = 0.0;
#line 239
uniform float GreyValue <
ui_type = "drag";
ui_min = 0.0; ui_max = 0.5;
ui_label = "Exposure 50% Greyvalue";
ui_tooltip = "Exposure 50% Greyvalue Set this Higher when using ACES Fitted and Lower when using Timoithy.";
ui_category = "Tonemapper Adjustments";
> = 0.128;
#line 247
uniform float Gamma <
ui_type = "drag";
ui_min = 1.0; ui_max = 4.0;
ui_label = "Gamma value";
ui_tooltip = "Most monitors/images use a value of 2.2. Setting this to 1 disables the inital color space conversion from gamma to linear.";
ui_category = "Tonemapper Adjustments";
> = 2.2;
#line 255
uniform float Contrast <
ui_type = "drag";
ui_min = 0.0; ui_max = 3.0;
ui_tooltip = "Contrast Adjustment.\n"
"Number 1.0 is default.";
ui_category = "Tonemapper Adjustments";
> = 1.0;
#line 263
uniform float Saturate <
ui_type = "drag";
ui_min = 0.0; ui_max = 2.0;
ui_label = "Image Saturation";
ui_tooltip = "Adjustment The amount to adjust the saturation of the color in the image.\n"
"Number 1.0 is default.";
ui_category = "Tonemapper Adjustments";
> = 1.0;
#line 272
uniform int Inv_Tonemappers <
ui_type = "combo";
ui_label = "Extract HDR Information";
ui_tooltip = "Changes how color get used for the other effects.\n"
"Turn this Off when the game has a good HDR implementation.";
ui_items = "Off\0Luma\0Color\0Max Color Brightness\0";
ui_category = "HDR";
> = 2;
#line 281
uniform float HDR_BP <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "HDR Power";
ui_tooltip = "Use adjsut the HDR Power, You can override this value and set it to like 1.5 or something.\n"
"Number 0.5 is default.";
ui_category = "HDR";
> = 0.5;
#line 290
uniform bool Bloom_BA_iToneMapper <
ui_label = "HDR Bloom Application";
ui_tooltip = "This will let you swap between Befor HDR ToneMapper and After.";
ui_category = "HDR";
> = 0;
#line 296
uniform int Auto_Exposure <
ui_type = "combo";
ui_label = "Auto Exposure Type";
ui_items = "Off\0Auto Exposure & Eye Adaptation\0Auto Exposure & Eyelids Adaptation\0";
ui_tooltip = "This will enable the shader to adjust Exposure automaticly.\n"
"This will also turn on Eye Adaptation for this shader.\n"
"This is based off Prod80's Port of an Auto-Expo Algo.\n"
"Padraic Hennessy, MJP and David Neubelt.";
ui_category = "Adaptation";
> = 1;
#line 307
uniform float Adapt_Adjust <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Eye Adapt Speed";
ui_tooltip = "Use this to Adjust Eye Adaptation Speed.\n"
"Set from Zero to One, Zero is the slowest.\n"
"Number 0.5 is default.";
ui_category = "Adaptation";
> = 0.5;
#line 317
uniform float Adapt_Seek <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Eye Adapt Seeking";
ui_tooltip = "Use this to Adjust Eye Seeking Radius for Average Brightness.\n"
"Set from 0 to 1, 1 is Full-Screen Average Brightness.\n"
"Number 0.5 is default.";
ui_category = "Adaptation";
> = 0.5;
#line 391
uniform int Debug_View <
ui_type = "combo";
ui_label = "Debug View";
ui_items = "Normal View\0Bloom View\0Heat Map\0";
ui_tooltip = "To view Shade & Blur effect on the game, movie piture & ect.";
ui_category = "Debugging";
> = 0;
#line 409
uniform float timer < source = "timer"; >;
#line 411
texture DepthBufferTex : DEPTH;
#line 413
sampler DepthBuffer
{
Texture = DepthBufferTex;
};
#line 418
texture BackBufferTex : COLOR;
#line 420
sampler BackBuffer
{
Texture = BackBufferTex;
#line 426
};
#line 428
texture texCurrColor { Width = 3840 * 0.5; Height = 2160 * 0.5; Format = RGBA8; MipLevels = 8;};
#line 430
sampler SamplerCurrBB
{
Texture = texCurrColor;
};
#line 436
texture2D BloomTexH_A	        	{ Width = 3840 / 2;  	Height = 2160 / 2;    Format = RGBA16F;};
sampler2D TextureBloomH_A	        { Texture = BloomTexH_A;};
#line 439
texture2D BloomTexV_A	        	{ Width = 3840 / 2;  	Height = 2160 / 2;    Format = RGBA16F;};
sampler2D TextureBloomV_A	    	{ Texture = BloomTexV_A;};
#line 442
texture2D BloomTexH_B	        	{ Width = 3840 / 4;  	Height = 2160 / 4;    Format = RGBA16F;};
sampler2D TextureBloomH_B        	{ Texture = BloomTexH_B;};
#line 445
texture2D BloomTexV_B	        	{ Width = 3840 / 4;  	Height = 2160 / 4;    Format = RGBA16F;};
sampler2D TextureBloomV_B	        { Texture = BloomTexV_B;};
#line 448
texture2D BloomTexH_C	        	{ Width = 3840 / 8;  	Height = 2160 / 8;    Format = RGBA16F;};
sampler2D TextureBloomH_C        	{ Texture = BloomTexH_C;};
#line 451
texture2D BloomTexV_C	        	{ Width = 3840 / 8;  	Height = 2160 / 8;    Format = RGBA16F;};
sampler2D TextureBloomV_C	        { Texture = BloomTexV_C;};
#line 454
texture2D BloomTex	        	{ Width = 3840 / 2;  	Height = 2160 / 2;    Format = RGBA16F;};
sampler2D TextureBloom	        { Texture = BloomTex;};
#line 459
texture TexFlareShared { Width = 3840 ; Height = 2160; Format = RGBA16F;};
#line 461
sampler SamplerFlare
{
Texture = TexFlareShared;
};
#line 475
uniform float frametime < source = "frametime";>;
#line 478
float Luma(float3 C)
{
float3 Luma;
#line 482
if ( 0  == 0)
{
Luma = float3(0.2126, 0.7152, 0.0722); 
}
else
{
Luma = float3(0.2627, 0.6780, 0.0593); 
}
#line 491
return dot(C,Luma);
}
#line 494
float3 ApplyPQ(float3 color)
{
#line 497
float m1 = 2610.0 / 4096.0 / 4;
float m2 = 2523.0 / 4096.0 * 128;
float c1 = 3424.0 / 4096.0;
float c2 = 2413.0 / 4096.0 * 32;
float c3 = 2392.0 / 4096.0 * 32;
float3 cp = pow(abs(color.xyz), m1);
color.xyz = pow((c1 + c2 * cp) / (1 + c3 * cp), m2);
return color;
}
#line 513
float Log2Exposure( in float avgLuminance, in float GreyValue )
{
float exposure   = 0.0f;
avgLuminance     = max(avgLuminance, 0.000001f);
#line 518
float linExp     = GreyValue / avgLuminance;
exposure         = log2( linExp );
return exposure;
}
#line 523
float CalcExposedColor(in float avgLuminance, in float offset, in float GreyValue )
{
float exposure   = Log2Exposure( avgLuminance, GreyValue  * 2.2 );
exposure         += offset; 
return exp2( exposure );
}
#line 531
texture texDS {Width = 256; Height = 256; Format = RG16F; MipLevels = 9;}; 
#line 533
sampler SamplerDS
{
Texture = texDS;
};
#line 538
texture texTA {Width = 64; Height = 64; Format = R16F; };
#line 540
sampler SamplerTA
{
Texture = texTA;
};
#line 545
texture texStored {Width = 64; Height = 64; Format = R16F; };
#line 547
sampler SamplerStored
{
Texture = texStored;
};
#line 552
float3 Downsample(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float2 texXY = texcoord;
float2 midHV = (Adapt_Seek-1) * float2(3840 * 0.5,2160 * 0.5) *  float2((1.0 / 3840), (1.0 / 2160));
float2 TC = float2((texXY.x*Adapt_Seek)-midHV.x,(texXY.y*Adapt_Seek)-midHV.y);
#line 558
return float3(Luma(tex2D(BackBuffer,TC).rgb),0,0);
}
#line 561
float PS_Temporal_Adaptation(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{   
float TT = 32500,EA = (1-Adapt_Adjust)*1250, L =  tex2Dlod(SamplerDS,float4(texcoord,0,11)).x, PL_A = tex2D(SamplerStored, float2(0.25,0.25)).x, PL_B = tex2D(SamplerStored, float2(0.25,0.75)).x;
EA = Auto_Exposure >= 1 ? PL_A + (L - PL_A) * (1.0 - exp(-frametime/EA)) : L;
TT = Auto_Exposure >= 1 ? PL_B + (L - PL_B) * (1.0 - exp(-frametime/TT)) : L;
float ITF= 1-(smoothstep(1,0,TT) < 0.85);
float FT = 2500, PStoredfade = tex2D(SamplerStored, float2(0.75,0.25)).x;
float TF = PStoredfade + (ITF - PStoredfade) * (1.0 - exp2(-frametime/FT)); 
#line 573
return texcoord.x > 0.5 ?  (texcoord.y > 0.5 ? 0 : TF) : (texcoord.y > 0.5 ? TT : EA);
}
#line 576
float max3(float x, float y, float z)
{
return max(x, max(y, z));
}
#line 581
float3 inv_Tonemapper(float4 color, int TM)
{
if(TM == 1)
return color.rgb * rcp((1.0 + max(color.w,0.001)) - max3(color.r, color.g, color.b));
else if(TM == 2)
return color.rgb * rcp(max((1.0 + color.w) - color.rgb,0.001));
else
return color.rgb * rcp(max((1.0 + lerp(-0.5,0,color.w) ) - Luma(color.rgb),0.001));
}
#line 592
float ColToneB(float hdrMax, float contrast, float shoulder, float midIn, float midOut)
{
return
-((-pow(midIn, contrast) + (midOut*(pow(hdrMax, contrast*shoulder)*pow(midIn, contrast) -
pow(hdrMax, contrast)*pow(midIn, contrast*shoulder)*midOut)) /
(pow(hdrMax, contrast*shoulder)*midOut - pow(midIn, contrast*shoulder)*midOut)) /
(pow(midIn, contrast*shoulder)*midOut));
}
#line 602
float ColToneC(float hdrMax, float contrast, float shoulder, float midIn, float midOut)
{
return (pow(hdrMax, contrast*shoulder)*pow(midIn, contrast) - pow(hdrMax, contrast)*pow(midIn, contrast*shoulder)*midOut) /
(pow(hdrMax, contrast*shoulder)*midOut - pow(midIn, contrast*shoulder)*midOut);
}
#line 609
float ColTone(float x, float4 p)
{
float z = pow(x, p.r);
return z / (pow(z, p.g)*p.b + p.a);
}
#line 615
float3 TimothyTonemapper(float3 color, float EX)
{
float hdrMax =   0  ? 25.0 : 16.0; 
float contrast = Contrast + 0.250; 
static float shoulder = 1.0; 
static float midIn = 0.11; 
float midOut =  0  ? 0.18/25.0 : 0.18; 
#line 623
float b = ColToneB(hdrMax, contrast, shoulder, midIn, midOut);
float c = ColToneC(hdrMax, contrast, shoulder, midIn, midOut);
#line 626
color *= EX;
#line 629
float peak = max(color.r, max(color.g, color.b));
peak = max( 1e-6f, peak);
#line 632
float3 ratio = color / peak;
peak = ColTone(peak, float4(contrast, shoulder, b, c) );
#line 637
float crosstalk = 4.0; 
float saturation = contrast * Saturate; 
float crossSaturation = contrast*16.0; 
#line 641
float white = WP;
#line 644
ratio = pow(abs(ratio), saturation / crossSaturation);
ratio = lerp(ratio, white, pow(peak, crosstalk));
ratio = pow(abs(ratio), crossSaturation);
#line 649
color = peak * ratio;
return color;
}
#line 654
static const float3x3 ACESInputMat =
float3x3( float3(0.59719, 0.35458, 0.04823),
float3(0.07600, 0.90834, 0.01566),
float3(0.02840, 0.13383, 0.83777));
#line 660
static const float3x3 ACESOutputMat =
float3x3( float3( 1.60475, -0.53108, -0.07367),
float3(-0.10208,  1.10813, -0.00605),
float3(-0.00327, -0.07276,  1.07602));
#line 665
float3 RRTAndODTFit(float3 v)
{
float3 a = v * (v + 0.0245786f) - 0.000090537f;
float3 b = v * (0.983729f * v + 0.4329510f) + 0.238081f;
return a / b;
}
#line 672
float3 ACESFitted( float3 color, float EX)
{
color *= EX + 0.5; 
color = mul(ACESInputMat,color);
color = RRTAndODTFit(color);
color = mul(ACESOutputMat,color);
#line 679
return  color/WP;
}
#line 683
float4 SimpleBlur(sampler2D InputTex, float2 Coord, float2 pixelsize)
{
float4 Blur = 0.0;
#line 687
static const float2 Offsets[4]=
{
float2(1.0, 1.0),
float2(1.0, -1.0),
float2(-1.0, 1.0),
float2(-1.0, -1.0)
};
#line 695
for (int i = 0; i < 4; i++)
{
Blur += tex2D(InputTex, Coord + Offsets[i] * pixelsize);
}
#line 700
return Blur * 0.25;
}
#line 703
struct BloomData
{
float4 Blur;
float2 Pixelsize;
float2 Coord;
float  Offset;
float  Weight;
float  WeightSum;
};
#line 713
float2 GetPixelSize(float texsize)
{
return  float2((1.0 / 3840), (1.0 / 2160)) * texsize;
}
#line 718
float3 Auto_Luma()
{
return float3(saturate(smoothstep(0,1,1-tex2D(SamplerTA,float2(0.25,0.25)).x)), 
tex2D(SamplerTA,float2(0.25,0.25)).x,                             
saturate(smoothstep(0,1,tex2D(SamplerTA,float2(0.75,0.25)).x)));  
}
#line 725
float3 Color_GS(float4 BC)
{   
float GS = Luma(BC.rgb), Saturate_A =  lerp(0,10,Saturation.x), Saturate_B = saturate(Saturation.y), AL = Auto_Luma().x;
#line 729
BC.rgb    = pow(abs(BC.rgb), BloomSensitivity);
BC.rgb /= max(GS, 0.001);
BC.a    = max(0.0, GS - CBT_Adjust);
BC.rgb *= BC.a;
#line 734
if(Auto_Bloom == 2 || Auto_Bloom == 4) 
Saturate_A *= lerp(0.0 + Saturate_B,1,AL);
#line 737
if(Auto_Bloom == 3 || Auto_Bloom == 5) 
Saturate_A *= lerp(2.0 - Saturate_B,1,AL);
#line 740
BC.rgb  = lerp(BC.a, BC.rgb, min(10,Saturate_A));
#line 742
return saturate(BC.rgb);
}
#line 745
void PS_CurrentInfo(float4 pos : SV_Position, float2 texcoords : TEXCOORD, out float4 Color : SV_Target0)
{   
Color = float4(Color_GS(tex2D(BackBuffer, texcoords)), 0);
}
#line 750
float4  Bloom(float2 Coord, float texsize, sampler2D InputTex, int Dir)
{
BloomData Bloom;
Bloom.Pixelsize      = GetPixelSize(texsize);
Bloom.Offset         = Bloom_Spread * 0.5 ;
#line 756
for (int i = 1; i <  8; i++)
{
float2 D = Dir ? float2(Bloom.Offset * Bloom.Pixelsize.x, 0) : float2( 0, Bloom.Offset * Bloom.Pixelsize.y);
Bloom.Weight     = pow(abs( 8 - i), BloomCurve);
Bloom.Blur      += tex2Dlod(InputTex, float4(Coord + D ,0,0)) * Bloom.Weight;
Bloom.Blur      += tex2Dlod(InputTex, float4(Coord - D ,0,0)) * Bloom.Weight;
Bloom.Offset    += Bloom_Spread ;
Bloom.WeightSum += Bloom.Weight;
}
#line 766
return Bloom.Blur /= Bloom.WeightSum * 2;
}
#line 769
float4 PS_BloomH_A(float4 pos : SV_Position, float2 Coord : TEXCOORD) : SV_Target
{   
return Bloom(Coord, 2, SamplerCurrBB, 1);
}
#line 774
float4 PS_BloomV_A(float4 pos : SV_Position, float2 Coord : TEXCOORD) : SV_Target
{
return Bloom(Coord, 2, TextureBloomH_A, 0);
}
#line 779
float4 PS_BloomH_B(float4 pos : SV_Position, float2 Coord : TEXCOORD) : SV_Target
{
return Bloom(Coord, 8, TextureBloomV_A, 1);
}
#line 784
float4 PS_BloomV_B(float4 pos : SV_Position, float2 Coord : TEXCOORD) : SV_Target
{
return Bloom(Coord, 8, TextureBloomH_B, 0);
}
#line 789
float4 PS_BloomH_C(float4 pos : SV_Position, float2 Coord : TEXCOORD) : SV_Target
{
return Bloom(Coord, 16, TextureBloomV_B, 1);
}
#line 794
float4 PS_BloomV_C(float4 pos : SV_Position, float2 Coord : TEXCOORD) : SV_Target
{
return Bloom(Coord, 16, TextureBloomH_C, 0);
}
#line 799
float4 Final_Bloom(float4 pos : SV_Position, float2 texcoords : TEXCOORD) : SV_Target
{
float3 LP = tex2D(BackBuffer, texcoords).rgb;
float4 Bloom  = SimpleBlur(TextureBloomH_A, texcoords, GetPixelSize(2)).rgba;
Bloom += SimpleBlur(TextureBloomV_A, texcoords, GetPixelSize(2)).rgba;
Bloom += SimpleBlur(TextureBloomH_B, texcoords, GetPixelSize(4)).rgba;
Bloom += SimpleBlur(TextureBloomV_B, texcoords, GetPixelSize(4)).rgba;
Bloom += SimpleBlur(TextureBloomH_C, texcoords, GetPixelSize(8)).rgba;
Bloom += SimpleBlur(TextureBloomV_C, texcoords, GetPixelSize(8)).rgba;
Bloom *= lerp(0,10,Bloom_Intensity.x) / 6; 
return float4(lerp(Bloom.rgb, max(Bloom.rgb - LP, 0.0), 0),0);
}
#line 812
float3 Green_Blue( float interpolant )
{
if( interpolant < 0.5 )
return float3(0.0, 1.0, 2.0 * interpolant);
else
return float3(0.0, 2.0 - 2.0 * interpolant, 1.0 );
}
#line 820
float3 Red_Green( float interpolant )
{
if( interpolant < 0.5 )
return float3(1.0, 2.0 * interpolant, 0.0);
else
return float3(2.0 - 2.0 * interpolant, 1.0, 0.0 );
}
#line 828
float3 FHeat( float interpolant )
{
float invertedInterpolant = interpolant;
if( invertedInterpolant < 0.5 )
{
float remappedFirstHalf = 1.0 - 2.0 * invertedInterpolant;
return Green_Blue( remappedFirstHalf );
}
else
{
float remappedSecondHalf = 2.0 - 2.0 * invertedInterpolant;
return Red_Green( remappedSecondHalf );
}
}
#line 843
float3 HeatMap( float interpolant )
{
if( interpolant < 1.0 / 6.0 )
{
float firstSegmentInterpolant = 6.0 * interpolant;
return ( 1.0 - firstSegmentInterpolant ) * float3(0.0, 0.0, 0.0) + firstSegmentInterpolant * float3(0.0, 0.0, 1.0);
}
else if( interpolant < 5.0 / 6.0 )
{
float midInterpolant = 0.25 * ( 6.0 * interpolant - 1.0 );
return FHeat( midInterpolant );
}
else
{
float lastSegmentInterpolant = 6.0 * interpolant - 5.0;
return ( 1.0 - lastSegmentInterpolant ) * float3(1.0, 0.0, 0.0) + lastSegmentInterpolant * float3(1.0, 1.0, 1.0);
}
}
#line 862
float Scale(float val,float max,float min) 
{
return (val - min) / (max - min);
}
#line 867
void GN(inout float Noise,float2 TC,float seed)
{
Noise = frac(tan(distance(TC*((seed+10)+ 1.61803398874989484820459 * 00000.1 ), float2( 1.61803398874989484820459 * 00000.1 ,  3.14159265358979323846264 * 00000.1 )))* 1.41421356237309504880169 * 10000.0 );
}
#line 872
float4 HDROut(float2 texcoords)
{   float4 Out, Bloom = SimpleBlur(TextureBloom, texcoords, GetPixelSize(1)).rgba;
float2 TC = 10 * texcoords.xy - 5;
float AL = Auto_Luma().y, Ex;
#line 877
if(Auto_Exposure >= 1)
Ex = Exp;
else
Ex = lerp(0,2.5,Scale(Exp, 4, -4));
#line 882
float NC = Bloom_Intensity.y;
#line 884
if(Auto_Bloom == 1 || Auto_Bloom == 4 || Auto_Bloom == 5)
NC *= max(0.25,Auto_Luma().x);
#line 887
float3 Noise, iFast, iReinhard, iReinhardLuma, Color = tex2D(BackBuffer, texcoords).rgb;
#line 889
GN( Noise.r, TC, 1 );
GN( Noise.g, TC, 2 );
GN( Noise.b, TC, 3 );
float3 SS  = smoothstep( 0.0, 0.1, Bloom.rgb );
SS *= lerp(0.0,0.1,saturate(Dither_Bloom));
Bloom.rgb = saturate( Bloom.rgb + Noise * SS );
#line 897
Bloom.rgb = lerp( 0.0, Bloom.rgb, saturate(NC));
#line 901
if(Tonemappers >= 1)
Color = lerp(Luma(Color),Color,Saturate);
#line 904
if( Gamma > 1. )
Color = pow(abs(Color),Gamma);
#line 907
if(!Bloom_BA_iToneMapper)
Color += Bloom.rgb;
#line 910
Color = max(0,Color);
#line 912
if(Inv_Tonemappers == 1)
Color = inv_Tonemapper(float4(Color,1-HDR_BP), 0);
else if(Inv_Tonemappers == 2)
Color = inv_Tonemapper(float4(Color,1-HDR_BP), 2);
else if(Inv_Tonemappers == 3)
Color = inv_Tonemapper(float4(Color,1-HDR_BP), 1);
#line 919
if (Bloom_BA_iToneMapper)
Color += Bloom.rgb;
#line 922
if(Auto_Exposure >= 1)
Ex = CalcExposedColor(AL,Ex,GreyValue);
else 
Ex = Ex;
#line 927
if(Tonemappers == 0)
Color = TimothyTonemapper(Color,Ex);
else if (Tonemappers == 1)
Color = ACESFitted(Color,Ex);
#line 945
if( Gamma > 1. )
Color = pow(abs(Color),rcp(2.2));
#line 950
float MD = 0;
if(Tonemappers >= 1)
Color = (Color - 0.5) * (Contrast) + 0.5;
#line 954
if (Debug_View == 0)
Out = float4(Color, 1.);
else if(Debug_View == 1)
Out = Bloom;
else if(Debug_View == 2)
Out = texcoords.y < 0.975 ? HeatMap(Luma( Color )): HeatMap(texcoords.x);
#line 963
texcoords.x = texcoords.x * 0.75 + 0.125;
texcoords *=  1.0 - float2(texcoords.x,texcoords.y);
float vignette = texcoords.x * texcoords.y  * 15.0, Mfactor = pow(smoothstep(0,1,vignette), Auto_Luma().y * 2.0);
if(Auto_Exposure > 1)
vignette = lerp(1,lerp(0,1,saturate(Mfactor)),Auto_Luma().z);
else
vignette = 1;
#line 971
return float4(Out.rgb * vignette,1.0);
}
#line 974
float PS_StoreInfo(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
return tex2D(SamplerTA,texcoord).x;
}
#line 980
float4 Out(float4 position : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float PosX = 0.9525f*3840* float2((1.0 / 3840), (1.0 / 2160)).x,PosY = 0.975f*2160* float2((1.0 / 3840), (1.0 / 2160)).y;
float3 Color = HDROut(texcoord).rgb,D,E,P,T,H,Three,DD,Dot,I,N,F,O;
#line 985
[branch] if(timer <= 12500)
{
#line 989
float PosXD = -0.035+PosX, offsetD = 0.001;
float3 OneD = all( abs(float2( texcoord.x -PosXD, texcoord.y-PosY)) < float2(0.0025,0.009));
float3 TwoD = all( abs(float2( texcoord.x -PosXD-offsetD, texcoord.y-PosY)) < float2(0.0025,0.007));
D = OneD-TwoD;
#line 995
float PosXE = -0.028+PosX, offsetE = 0.0005;
float3 OneE = all( abs(float2( texcoord.x -PosXE, texcoord.y-PosY)) < float2(0.003,0.009));
float3 TwoE = all( abs(float2( texcoord.x -PosXE-offsetE, texcoord.y-PosY)) < float2(0.0025,0.007));
float3 ThreeE = all( abs(float2( texcoord.x -PosXE, texcoord.y-PosY)) < float2(0.003,0.001));
E = (OneE-TwoE)+ThreeE;
#line 1002
float PosXP = -0.0215+PosX, PosYP = -0.0025+PosY, offsetP = 0.001, offsetP1 = 0.002;
float3 OneP = all( abs(float2( texcoord.x -PosXP, texcoord.y-PosYP)) < float2(0.0025,0.009*0.775));
float3 TwoP = all( abs(float2( texcoord.x -PosXP-offsetP, texcoord.y-PosYP)) < float2(0.0025,0.007*0.680));
float3 ThreeP = all( abs(float2( texcoord.x -PosXP+offsetP1, texcoord.y-PosY)) < float2(0.0005,0.009));
P = (OneP-TwoP) + ThreeP;
#line 1009
float PosXT = -0.014+PosX, PosYT = -0.008+PosY;
float3 OneT = all( abs(float2( texcoord.x -PosXT, texcoord.y-PosYT)) < float2(0.003,0.001));
float3 TwoT = all( abs(float2( texcoord.x -PosXT, texcoord.y-PosY)) < float2(0.000625,0.009));
T = OneT+TwoT;
#line 1015
float PosXH = -0.0072+PosX;
float3 OneH = all( abs(float2( texcoord.x -PosXH, texcoord.y-PosY)) < float2(0.002,0.001));
float3 TwoH = all( abs(float2( texcoord.x -PosXH, texcoord.y-PosY)) < float2(0.002,0.009));
float3 ThreeH = all( abs(float2( texcoord.x -PosXH, texcoord.y-PosY)) < float2(0.00325,0.009));
H = (OneH-TwoH)+ThreeH;
#line 1022
float offsetFive = 0.001, PosX3 = -0.001+PosX;
float3 OneThree = all( abs(float2( texcoord.x -PosX3, texcoord.y-PosY)) < float2(0.002,0.009));
float3 TwoThree = all( abs(float2( texcoord.x -PosX3 - offsetFive, texcoord.y-PosY)) < float2(0.003,0.007));
float3 ThreeThree = all( abs(float2( texcoord.x -PosX3, texcoord.y-PosY)) < float2(0.002,0.001));
Three = (OneThree-TwoThree)+ThreeThree;
#line 1029
float PosXDD = 0.006+PosX, offsetDD = 0.001;
float3 OneDD = all( abs(float2( texcoord.x -PosXDD, texcoord.y-PosY)) < float2(0.0025,0.009));
float3 TwoDD = all( abs(float2( texcoord.x -PosXDD-offsetDD, texcoord.y-PosY)) < float2(0.0025,0.007));
DD = OneDD-TwoDD;
#line 1035
float PosXDot = 0.011+PosX, PosYDot = 0.008+PosY;
float3 OneDot = all( abs(float2( texcoord.x -PosXDot, texcoord.y-PosYDot)) < float2(0.00075,0.0015));
Dot = OneDot;
#line 1041
float PosXI = 0.0155+PosX, PosYI = 0.004+PosY, PosYII = 0.008+PosY;
float3 OneI = all( abs(float2( texcoord.x - PosXI, texcoord.y - PosY)) < float2(0.003,0.001));
float3 TwoI = all( abs(float2( texcoord.x - PosXI, texcoord.y - PosYI)) < float2(0.000625,0.005));
float3 ThreeI = all( abs(float2( texcoord.x - PosXI, texcoord.y - PosYII)) < float2(0.003,0.001));
I = OneI+TwoI+ThreeI;
#line 1048
float PosXN = 0.0225+PosX, PosYN = 0.005+PosY,offsetN = -0.001;
float3 OneN = all( abs(float2( texcoord.x - PosXN, texcoord.y - PosYN)) < float2(0.002,0.004));
float3 TwoN = all( abs(float2( texcoord.x - PosXN, texcoord.y - PosYN - offsetN)) < float2(0.003,0.005));
N = OneN-TwoN;
#line 1054
float PosXF = 0.029+PosX, PosYF = 0.004+PosY, offsetF = 0.0005, offsetF1 = 0.001;
float3 OneF = all( abs(float2( texcoord.x -PosXF-offsetF, texcoord.y-PosYF-offsetF1)) < float2(0.002,0.004));
float3 TwoF = all( abs(float2( texcoord.x -PosXF, texcoord.y-PosYF)) < float2(0.0025,0.005));
float3 ThreeF = all( abs(float2( texcoord.x -PosXF, texcoord.y-PosYF)) < float2(0.0015,0.00075));
F = (OneF-TwoF)+ThreeF;
#line 1061
float PosXO = 0.035+PosX, PosYO = 0.004+PosY;
float3 OneO = all( abs(float2( texcoord.x -PosXO, texcoord.y-PosYO)) < float2(0.003,0.005));
float3 TwoO = all( abs(float2( texcoord.x -PosXO, texcoord.y-PosYO)) < float2(0.002,0.003));
O = OneO-TwoO;
#line 1066
return float4(D+E+P+T+H+Three+DD+Dot+I+N+F+O,1.) ? 1-texcoord.y*50.0+48.35f : float4(Color,1.);
}
else
return float4(Color,1.);
}
#line 1075
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 1083
technique Blooming_HDR
{
pass Store_Info
{
VertexShader = PostProcessVS;
PixelShader = PS_StoreInfo;
RenderTarget = texStored;
}
pass Current_Info
{
VertexShader = PostProcessVS;
PixelShader = PS_CurrentInfo;
RenderTarget0 = texCurrColor;
}
pass BloomH_A
{
VertexShader  = PostProcessVS;
PixelShader   = PS_BloomH_A;
RenderTarget = BloomTexH_A;
}
pass BloomV_A
{
VertexShader  = PostProcessVS;
PixelShader   = PS_BloomV_A;
RenderTarget = BloomTexV_A;
}
pass BloomV_B
{
VertexShader  = PostProcessVS;
PixelShader   = PS_BloomH_B;
RenderTarget = BloomTexH_B;
}
pass BloomV_B
{
VertexShader  = PostProcessVS;
PixelShader   = PS_BloomV_B;
RenderTarget = BloomTexV_B;
}
pass BloomV_C
{
VertexShader  = PostProcessVS;
PixelShader   = PS_BloomH_C;
RenderTarget = BloomTexH_C;
}
pass BloomV_C
{
VertexShader  = PostProcessVS;
PixelShader   = PS_BloomV_C;
RenderTarget = BloomTexV_C;
}
pass Bloom
{
VertexShader  = PostProcessVS;
PixelShader   = Final_Bloom;
RenderTarget = BloomTex;
}
pass Downsampler
{
VertexShader = PostProcessVS;
PixelShader = Downsample;
RenderTarget = texDS;
}
pass Temporal_Adaptation
{
VertexShader = PostProcessVS;
PixelShader = PS_Temporal_Adaptation;
RenderTarget = texTA;
}
pass HDROut
{
VertexShader = PostProcessVS;
PixelShader = Out;
#line 1158
}
#line 1160
}

