#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\BulgePinch.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 5 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\BulgePinch.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/BulgePinch.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/RadegastShaders.CommonPositional.fxh"
#line 1
uniform float radius <
#line 5
ui_type = "slider";
#line 7
ui_label="Radius";
ui_min = 0.0;
ui_max = 1.0;
> = 0.5;
#line 12
uniform float2 coordinates <
#line 16
ui_type = "slider";
#line 18
ui_label="Coordinates";
ui_tooltip="The X and Y position of the center of the effect.";
ui_min = 0.0;
ui_max = 1.0;
> = float2(0.25, 0.25);
#line 24
uniform bool use_mouse_point <
ui_label="Use Mouse Coordinates";
> = false;
#line 28
uniform float tension <
#line 32
ui_type = "slider";
#line 34
ui_min = 0.; ui_max = 10.; ui_step = 0.001;
> = 1.0;
#line 37
uniform float aspect_ratio <
#line 41
ui_type = "slider";
#line 43
ui_label="Aspect Ratio";
ui_min = -100.0;
ui_max = 100.0;
> = 0;
#line 48
uniform float min_depth <
#line 52
ui_type = "slider";
#line 54
ui_label="Minimum Depth";
ui_min=0.0;
ui_max=1.0;
> = 0;
#line 59
uniform float anim_rate <
source = "timer";
>;
#line 63
uniform float2 mouse_coordinates <
source= "mousepoint";
>;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/BulgePinch.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/RadegastShaders.BlendingModes.fxh"
#line 1
uniform int blending_mode <
ui_type = "combo";
ui_label = "Blending Mode";
ui_items = "Normal\0Add\0Multiply\0Subtract\0Divide\0Darker\0Lighter\0";
ui_tooltip = "Choose a blending mode.";
> = 0;
#line 8
float4 applyBlendingMode(float4 base, float4 color) {
switch(blending_mode) {
case 1:
return color + base;
case 2:
return color * base;
case 3:
return color - base;
case 4:
return color / base;
case 5:
if(length(color.rgb) > length(base.rgb)) return base;
return color;
case 6:
if(length(color.rgb) < length(base.rgb)) return base;
return color;
}
return color;
}
#line 28
float4 applyBlendingMode(float4 base, float4 color, float percent) {
switch(blending_mode) {
case 1:
return lerp(base, color + base, percent);
case 2:
return lerp(base, color * base, percent);
case 3:
return lerp(base, color - base, percent);
case 4:
return lerp(base, color / base, percent);
case 5:
if(length(color.rgb) > length(base.rgb)) return base;
return color;
case 6:
if(length(color.rgb) < length(base.rgb)) return base;
return color;
}
return color;
#line 47
}
#line 2 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/BulgePinch.fxh"
#line 4
uniform float magnitude <
#line 8
ui_type = "slider";
#line 10
ui_min = -1.0;
ui_max = 1.0;
ui_tooltip = "The magnitude of the distortion. Positive values cause the image to bulge out. Negative values cause the image to pinch in.";
> = -0.5;
#line 15
uniform int animate <
ui_type = "combo";
ui_label = "Animate";
ui_items = "No\0Yes\0";
ui_tooltip = "Animates the effect.";
> = 0;
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\BulgePinch.fx"
#line 8
texture texColorBuffer : COLOR;
#line 10
texture pbDistortTarget
{
Width = 1920;
Height = 1080;
Format = RGBA8;
};
#line 17
sampler samplerColor
{
Texture = texColorBuffer;
#line 21
AddressU = MIRROR;
AddressV = MIRROR;
AddressW = MIRROR;
#line 25
MagFilter = LINEAR;
MinFilter = LINEAR;
MipFilter = LINEAR;
#line 29
MinLOD = 0.0f;
MaxLOD = 1000.0f;
#line 32
MipLODBias = 0.0f;
#line 34
SRGBTexture = false;
};
#line 37
sampler result
{
Texture = pbDistortTarget;
};
#line 43
void FullScreenVS(uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD0)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
#line 48
position = float4( texcoord * float2(2, -2) + float2(-1, 1), 0, 1);
#line 51
}
#line 54
float4 PBDistort(float4 pos : SV_Position, float2 texcoord : TEXCOORD0) : SV_TARGET
{
const float ar_raw = 1.0 * (float)1080 / (float)1920;
float ar = lerp(ar_raw, 1, aspect_ratio * 0.01);
#line 59
float2 center = coordinates / 2.0;
if (use_mouse_point)
center = float2(mouse_coordinates.x * (1.0 / 1920) / 2.0, mouse_coordinates.y * (1.0 / 1080) / 2.0);
#line 63
float2 tc = texcoord - center;
#line 65
float4 color;
const float4 base = tex2D(samplerColor, texcoord);
const float depth = ReShade::GetLinearizedDepth(texcoord).r;
#line 69
center.x /= ar;
tc.x /= ar;
#line 72
float dist = distance(tc, center);
if (dist < radius && depth >= min_depth)
{
float anim_mag = (animate == 1 ? magnitude * sin(radians(anim_rate * 0.05)) : magnitude);
float tension_radius = lerp(dist, radius, tension);
float percent = (dist)/tension_radius;
if(anim_mag > 0)
tc = (tc-center) * lerp(1.0, smoothstep(0.0, radius/dist, percent), anim_mag * 0.75);
else
tc = (tc-center) * lerp(1.0, pow(abs(percent), 1.0 + anim_mag * 0.75) * radius/dist, 1.0 - percent);
#line 83
tc += (2*center);
tc.x *= ar;
#line 86
color = tex2D(samplerColor, tc);
color = applyBlendingMode(base, color, 1 - percent);
}
else {
color = tex2D(samplerColor, texcoord);
}
#line 93
return color;
}
#line 97
technique BulgePinch < ui_label="Bulge/Pinch";>
{
pass p0
{
VertexShader = FullScreenVS;
PixelShader = PBDistort;
}
};
