#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CRT_Lottes.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CRT_Lottes.fx"
#line 56
uniform float2 f2Warp <
ui_label = "Scanline Warp";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 64.0;
ui_step  = 0.01;
> = float2(48.0, 24.0);
#line 64
uniform float fThin <
ui_label = "Scanline Thinness";
ui_type  = "drag";
ui_min   = 0.5;
ui_max   = 1.0;
ui_step  = 0.001;
> = 0.7;
#line 72
uniform float fBlur <
ui_label = "Horizontal Scan Blur";
ui_type  = "drag";
ui_min   = 1.0;
ui_max   = 3.0;
ui_step  = 0.001;
> = 2.5;
#line 80
uniform float fMask <
ui_label = "Shadow Mask";
ui_type  = "drag";
ui_min   = 0.25;
ui_max   = 1.0;
ui_step  = 0.001;
> = 0.5;
#line 109
uniform float fDownscale <
ui_label = "Resolution Downscale";
ui_type  = "drag";
ui_min   = 1.0;
ui_max   = 256.0;
ui_step  = 0.25;
> = 2.0;
#line 147
sampler2D sBackBuffer_Scale {
Texture     = ReShade::BackBufferTex;
SRGBTexture = true;
#line 151
MinFilter   = LINEAR;
#line 155
MagFilter   = POINT;
};
#line 159
sampler2D sBackBuffer_CRT {
Texture     = ReShade::BackBufferTex;
SRGBTexture = true;
MinFilter   = LINEAR;
MagFilter   = LINEAR;
};
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CRT_Lottes.fxh"
#line 227
 float CrtsMax3F1( float a, float b, float c){
return max(a,max(b,c));}
#line 237
 float4 CrtsTone(
 float contrast,
 float saturation,
 float thin,
 float mask){
#line 250
mask=0.5+mask*0.5;
#line 253
 float4 ret;
 float midOut=0.18/((1.5-thin)*(0.5*mask+0.5));
 float pMidIn=pow(0.18,contrast);
ret.x=contrast;
ret.y=((-pMidIn)+midOut)/((1.0-pMidIn)*midOut);
ret.z=((-pMidIn)*midOut+pMidIn)/(midOut*(-pMidIn)+midOut);
ret.w=contrast+saturation;
return ret;}
#line 290
 float3 CrtsMask( float2 pos, float dark){
#line 301
 float3 m= float3(1.0,1.0,1.0);
 float x= frac(pos.x*(1.0/3.0));
if(x<(1.0/3.0))m.r=dark;
else if(x<(2.0/3.0))m.g=dark;
else m.b=dark;
return m;
#line 322
}
#line 357
 float3 CrtsFilter(
#line 360
 float2 ipos,
#line 363
 float2 inputSizeDivOutputSize,
#line 366
 float2 halfInputSize,
#line 369
 float2 rcpInputSize,
#line 372
 float2 rcpOutputSize,
#line 375
 float2 twoDivOutputSize,
#line 378
 float inputHeight,
#line 385
 float2 warp,
#line 392
 float thin,
#line 399
 float blur,
#line 406
 float mask,
#line 409
 float4 tone
#line 411
){
#line 426
 float2 pos;
#line 429
pos=ipos*twoDivOutputSize- float2(1.0,1.0);
#line 431
pos*= float2(
1.0+(pos.y*pos.y)*warp.x,
1.0+(pos.x*pos.x)*warp.y);
#line 435
 float vin=1.0-(
(1.0- saturate(pos.x*pos.x))*(1.0- saturate(pos.y*pos.y)));
vin= saturate((-vin)*inputHeight+inputHeight);
#line 439
pos=pos*halfInputSize+halfInputSize;
#line 445
 float y0=floor(pos.y-0.5)+0.5;
#line 461
 float x0=floor(pos.x-1.5)+0.5;
#line 463
 float2 p= float2(x0*rcpInputSize.x,y0*rcpInputSize.y);
#line 465
 float3 colA0= tex2D(sBackBuffer_CRT, p).rgb;
p.x+=rcpInputSize.x;
 float3 colA1= tex2D(sBackBuffer_CRT, p).rgb;
p.x+=rcpInputSize.x;
 float3 colA2= tex2D(sBackBuffer_CRT, p).rgb;
p.x+=rcpInputSize.x;
 float3 colA3= tex2D(sBackBuffer_CRT, p).rgb;
p.y+=rcpInputSize.y;
 float3 colB3= tex2D(sBackBuffer_CRT, p).rgb;
p.x-=rcpInputSize.x;
 float3 colB2= tex2D(sBackBuffer_CRT, p).rgb;
p.x-=rcpInputSize.x;
 float3 colB1= tex2D(sBackBuffer_CRT, p).rgb;
p.x-=rcpInputSize.x;
 float3 colB0= tex2D(sBackBuffer_CRT, p).rgb;
#line 485
 float off=pos.y-y0;
 float pi2=6.28318530717958;
 float hlf=0.5;
 float scanA=cos(min(0.5,  off *thin     )*pi2)*hlf+hlf;
 float scanB=cos(min(0.5,(-off)*thin+thin)*pi2)*hlf+hlf;
#line 501
 float off0=pos.x-x0;
 float off1=off0-1.0;
 float off2=off0-2.0;
 float off3=off0-3.0;
 float pix0=exp2(blur*off0*off0);
 float pix1=exp2(blur*off1*off1);
 float pix2=exp2(blur*off2*off2);
 float pix3=exp2(blur*off3*off3);
 float pixT= (1.0/(pix0+pix1+pix2+pix3));
#line 512
pixT*=vin;
#line 514
scanA*=pixT;
scanB*=pixT;
#line 517
 float3 color=
(colA0*pix0+colA1*pix1+colA2*pix2+colA3*pix3)*scanA +
(colB0*pix0+colB1*pix1+colB2*pix2+colB3*pix3)*scanB;
#line 523
color*=CrtsMask(ipos,mask);
#line 528
 float peak=max(1.0/(256.0*65536.0),
CrtsMax3F1(color.r,color.g,color.b));
#line 531
 float3 ratio=color* (1.0/(peak));
#line 534
peak=pow(peak,tone.x);
#line 536
peak=peak* (1.0/(peak*tone.y+tone.z));
#line 539
ratio=pow(ratio, float3(tone.w,tone.w,tone.w));
#line 542
return ratio*peak;
#line 547
}
#line 168 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CRT_Lottes.fx"
#line 173
float2 scale_uv(float2 uv, float2 scale, float2 center) {
return (uv - center) * scale + center;
}
#line 177
float2 scale_uv(float2 uv, float2 scale) {
return scale_uv(uv, scale, 0.5);
}
#line 185
void PS_Downscale(
float4 position  : SV_POSITION,
float2 uv        : TEXCOORD,
out float4 color : SV_TARGET
) {
color = tex2D(sBackBuffer_Scale, scale_uv(uv,  fDownscale));
}
#line 193
void PS_Upscale(
float4 position  : SV_POSITION,
float2 uv        : TEXCOORD,
out float4 color : SV_TARGET
) {
color = tex2D(sBackBuffer_Scale, scale_uv(uv, 1.0 /  fDownscale));
}
#line 202
void PS_CRT_Lottes(
float4 position  : SV_POSITION,
float2 uv        : TEXCOORD,
out float4 color : SV_TARGET
) {
float2 coord = uv * ReShade::ScreenSize;
color.a = 1.0;
color.rgb = CrtsFilter(
coord,
 (ReShade::ScreenSize / fDownscale) * ReShade::PixelSize,
 (ReShade::ScreenSize / fDownscale) * 0.5,
1.0 /  (ReShade::ScreenSize / fDownscale),
ReShade::PixelSize,
ReShade::PixelSize * 2.0,
 (float(1080) / fDownscale),
1.0 / f2Warp,
fThin,
-fBlur,
fMask,
CrtsTone(1.0, 0.0, fThin, fMask)
);
}
#line 227
technique CRT_Lottes {
#line 229
pass Downscale {
VertexShader    = PostProcessVS;
PixelShader     = PS_Downscale;
SRGBWriteEnable = true;
}
pass Upscale {
VertexShader    = PostProcessVS;
PixelShader     = PS_Upscale;
SRGBWriteEnable = true;
}
#line 240
pass CRT_Lottes {
VertexShader    = PostProcessVS;
PixelShader     = PS_CRT_Lottes;
SRGBWriteEnable = true;
}
}

