#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ColorLab.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 11 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ColorLab.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 12 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ColorLab.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ColorLab.fxh"
#line 13
namespace FXShaders { namespace ColorLab
{
#line 16
static const float Gamma = 2.2;
static const float GammaInv = 1.0 / Gamma;
#line 19
static const float L_k = 903.3;
static const float L_e = 0.008856;
#line 22
static const float WhitePoint = 1.0;
#line 24
static const float3x3 RGBToXYZ_sRGB = float3x3(
0.4124564, 0.3575761, 0.1804375,
0.2126729, 0.7151522, 0.0721750,
0.0193339, 0.1191920, 0.9503041);
#line 29
static const float3x3 XYZToRGB_sRGB = float3x3(
3.2404542, -1.5371385, -0.4985314,
-0.9692660,  1.8760108,  0.0415560,
0.0556434, -0.2040259,  1.0572252);
#line 34
float3 gamma_to_linear(float3 c, float g)
{
return pow(abs(c), g);
}
#line 39
float3 gamma_to_linear(float3 c)
{
return gamma_to_linear(c, Gamma);
}
#line 44
float3 linear_to_gamma(float3 c, float g)
{
return pow(abs(c), rcp(g));
}
#line 49
float3 linear_to_gamma(float3 c)
{
return pow(abs(c), GammaInv);
}
#line 54
float3 srgb_to_linear(float3 c)
{
return (c < 0.04045)
? c / 12.92
: pow(abs((c + 0.055) / 1.055), 2.4);
}
#line 61
float3 linear_to_srgb(float3 c)
{
return (c < 0.0031308)
? 12.92 * c
: 1.055 * pow(abs(c), rcp(2.4)) - 0.055;
}
#line 68
float3 l_to_linear(float3 c)
{
return (c < 0.08)
? (100 * c) / L_k
: pow(abs((c + 0.16) / 1.16), 3.0);
}
#line 75
float3 linear_to_l(float3 c)
{
return (c < L_e)
? (c * L_k) / 100.0
: 1.16 * pow(abs(c), rcp(3.0)) - 0.16;
}
#line 82
float3 rgb_to_xyz(float3 c)
{
return mul(RGBToXYZ_sRGB, c);
}
#line 87
float3 xyz_to_rgb(float3 c)
{
return mul(XYZToRGB_sRGB, c);
}
#line 92
float3 xyz_to_lab(float3 c, float w)
{
c /= w;
#line 96
c = (c > L_e)
? pow(abs(c), rcp(3.0))
: (L_k * c + 16.0) / 116.0;
#line 100
float3 lab;
lab.x = 116.0 * c.y - 16.0;
lab.y = 500.0 * (c.x - c.y);
lab.z = 200.0 * (c.y - c.z);
#line 105
return lab;
}
#line 108
float3 xyz_to_lab(float3 c)
{
return xyz_to_lab(c, WhitePoint);
}
#line 113
float3 lab_to_xyz(float3 lab, float w)
{
float3 c;
c.y = (lab.x + 16.0) / 116.0;
c.x = lab.y / 500.0 + c.y;
c.z = c.y - lab.z / 200.0;
#line 120
float f3 = c.x * c.x * c.x;
c.x = (f3 > L_e)
? f3
: (116.0 * c.x - 16.0) / L_k;
#line 125
c.y = (lab.x > L_k * L_e)
? pow(abs((lab.x + 16.0) / 116.0), 3.0)
: lab.x / L_k;
#line 129
f3 = c.z * c.z * c.z;
c.z = (f3 > L_e)
? f3
: (116.0 * c.z - 16.0) / L_k;
#line 134
c *= w;
return c;
}
#line 138
float3 lab_to_xyz(float3 lab)
{
return lab_to_xyz(lab, WhitePoint);
}
#line 143
float3 rgb_to_lab(float3 c, float w)
{
return xyz_to_lab(rgb_to_xyz(c), w);
}
#line 148
float3 rgb_to_lab(float3 c)
{
return rgb_to_lab(c, WhitePoint);
}
#line 153
float3 lab_to_rgb(float3 c, float w)
{
return xyz_to_rgb(lab_to_xyz(c, w));
}
#line 158
float3 lab_to_rgb(float3 c)
{
return lab_to_rgb(c, WhitePoint);
}
#line 163
}}
#line 13 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ColorLab.fx"
#line 17
namespace FXShaders
{
#line 22
uniform float3 Multiplier
<
     ui_type = "drag"; 
#line 26
ui_tooltip =
"Generic multiplier to each component of the L*a*b color space.\n"
"\nDefault: 1.0 1.0 1.0";
ui_type = "drag";
ui_min = 0.0;
ui_max = 2.0;
ui_step = 0.01;
> = 1.0;
#line 37
sampler BackBuffer
{
Texture = ReShade::BackBufferTex;
SRGBTexture = true;
MinFilter = POINT;
MagFilter = POINT;
MipFilter = POINT;
};
#line 46
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(BackBuffer, uv);
color.xyz = ColorLab::rgb_to_lab(color.rgb);
#line 51
color.xyz *= Multiplier;
#line 53
color.rgb = ColorLab::lab_to_rgb(color.xyz);
return color;
}
#line 57
technique ColorLab
{
pass
{
VertexShader = PostProcessVS;
PixelShader = MainPS;
SRGBWriteEnable = true;
}
}
#line 67
}

