#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\ColorfulPoster.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 37 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\ColorfulPoster.fx"
#line 48
uniform int iUILumaLevels <
ui_type = "drag";
ui_category =  "Posterization";
ui_label = "Luma Posterize Levels";
ui_min = 1; ui_max = 20;
> = 16;
#line 55
uniform int iUIStepType <
ui_type = "combo";
ui_category =  "Posterization";
ui_label = "Curve Type";
ui_items = "Linear\0Smoothstep\0Logistic\0Sigmoid\0";
> = 2;
#line 62
uniform float fUIStepContinuity <
ui_type = "drag";
ui_category =  "Posterization";
ui_label = "Continuity";
ui_tooltip = "Broken up <-> Connected";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.01;
> = 1.0;
#line 71
uniform float fUISlope <
ui_type = "drag";
ui_category =  "Posterization";
ui_label = "Slope Logistic Curve";
ui_min = 0.0; ui_max = 40.0;
ui_step = 0.1;
> = 13.0;
#line 79
uniform bool iUIDebugOverlayPosterizeLevels <
ui_category =  "Posterization";
ui_label = "Show Posterization as Curve (Magenta)";
> = 0;
#line 86
uniform float fUITint <
ui_type = "drag";
ui_category =  "Color";
ui_label = "Tint Strength";
ui_min = 0.0; ui_max = 1.0;
> = 1.0;
#line 95
uniform float fUIStrength <
ui_type = "drag";
ui_category =  "Effect";
ui_label = "Strength";
ui_min = 0.0; ui_max = 1.0;
> = 1.0;
#line 108
float Posterize(float x, int numLevels, float continuity, float slope, int type) {
float stepheight = 1.0 / numLevels;
float stepnum = floor(x * numLevels);
float frc = frac(x * numLevels);
float step1 = floor(frc) * stepheight;
float step2;
#line 115
if(type == 1)
step2 = smoothstep(0.0, 1.0, frc) * stepheight;
else if(type == 2)
step2 = (1.0 / (1.0 + exp(-slope*(frc - 0.5)))) * stepheight;
else if(type == 3)
step2 = (frc < 0.5 ? pow(frc, slope) * pow(2.0, slope) * 0.5 : 1.0 - pow(1.0 - frc, slope) * pow(2.0, slope) * 0.5) * stepheight;
else
step2 = frc * stepheight;
#line 124
return lerp(step1, step2, continuity) + stepheight * stepnum;
}
#line 127
float4 RGBtoCMYK(float3 color) {
float3 CMY;
float K;
K = 1.0 - max(color.r, max(color.g, color.b));
CMY = (1.0 - color - K) / (1.0 - K);
return float4(CMY, K);
}
#line 135
float3 CMYKtoRGB(float4 cmyk) {
return (1.0.xxx - cmyk.xyz) * (1.0 - cmyk.w);
}
#line 139
float3 DrawDebugCurve(float3 background, float2 texcoord, float value, float3 color, float curveDiv) {
float p = exp(-(1080/curveDiv) * length(texcoord - float2(texcoord.x, 1.0 - value)));
return lerp(background, color, saturate(p));
}
#line 147
float3 ColorfulPoster_PS(float4 vpos : SV_Position, float2 texcoord : TexCoord) : SV_Target {
static const float3 LumaCoeff = float3(0.2126, 0.7151, 0.0721);
#line 152
float3 backbuffer = tex2D(ReShade::BackBuffer, texcoord).rgb;
#line 157
float luma = dot(backbuffer, LumaCoeff);
float3 chroma = backbuffer - luma;
float3 lumaPoster = Posterize(luma, iUILumaLevels, fUIStepContinuity, fUISlope, iUIStepType).rrr;
#line 164
float3 mask, image, colorLayer;
#line 167
float4 backbufferCMYK = RGBtoCMYK(backbuffer);
backbufferCMYK.xyz += float3(0.2, -0.1, -0.2);
backbufferCMYK.w = 0.0;
#line 172
mask = CMYKtoRGB(saturate(backbufferCMYK));
#line 175
image = chroma + lumaPoster;
#line 178
colorLayer = lerp(2*image*mask, 1.0 - 2.0 * (1.0 - image) * (1.0 - mask), step(0.5, luma.r));
colorLayer = lerp(image, colorLayer, fUITint);
#line 184
float3 result = lerp(backbuffer, colorLayer, fUIStrength);
#line 186
if(iUIDebugOverlayPosterizeLevels == 1) {
float value = Posterize(texcoord.x, iUILumaLevels, fUIStepContinuity, fUISlope, iUIStepType);
result = DrawDebugCurve(result, texcoord, value, float3(1.0, 0.0, 1.0), 1.0);
}
#line 194
return result;
}
#line 197
technique ColorfulPoster
{
pass {
VertexShader = PostProcessVS;
PixelShader = ColorfulPoster_PS;
}
}

