#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\FilmicSharpen.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 15 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\FilmicSharpen.fx"
#line 17
uniform float Strength <      ui_type = "slider"; 
ui_label = "Strength";
ui_min = 0.0; ui_max = 100.0; ui_step = 0.01;
> = 60.0;
#line 22
uniform float Offset <      ui_type = "slider"; 
ui_label = "Radius";
ui_tooltip = "High-pass cross offset in pixels";
ui_min = 0.0; ui_max = 2.0; ui_step = 0.01;
> = 0.1;
#line 28
uniform float Clamp <      ui_type = "slider"; 
ui_label = "Clamping";
ui_min = 0.5; ui_max = 1.0; ui_step = 0.001;
> = 0.65;
#line 33
uniform bool UseMask <       ui_type = "input"; 
ui_label = "Sharpen only center";
ui_tooltip = "Sharpen only in center of the image";
> = false;
#line 38
uniform int Coefficient <        ui_type = "radio"; 
ui_tooltip = "For digital video signal use BT.709, for analog (like VGA) use BT.601";
ui_label = "YUV coefficients";
ui_items = "BT.709 - digital\0BT.601 - analog\0";
ui_category = "Additional settings";
ui_category_closed = true;
> = 0;
#line 46
uniform bool Preview <       ui_type = "input"; 
ui_label = "Preview sharpen layer";
ui_tooltip = "Preview sharpen layer and mask for adjustment.\n"
"If you don't see red strokes,\n"
"try changing Preprocessor Definitions in the Settings tab.";
ui_category = "Debug View";
ui_category_closed = true;
> = false;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 59 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\FilmicSharpen.fx"
#line 62
sampler BackBuffer
{
Texture = ReShade::BackBufferTex;
AddressU = MIRROR;
AddressV = MIRROR;
#line 70
};
#line 77
static const float3 Luma709 = float3(0.2126, 0.7152, 0.0722);
#line 79
static const float3 Luma601 = float3(0.299, 0.587, 0.114);
#line 82
float Overlay(float LayerA, float LayerB)
{
float MinA = min(LayerA, 0.5);
float MinB = min(LayerB, 0.5);
float MaxA = max(LayerA, 0.5);
float MaxB = max(LayerB, 0.5);
return 2.0*((MinA*MinB+MaxA)+(MaxB-MaxA*MaxB))-1.5;
}
#line 92
float Overlay(float LayerAB)
{
float MinAB = min(LayerAB, 0.5);
float MaxAB = max(LayerAB, 0.5);
return 2.0*((MinAB*MinAB+MaxAB)+(MaxAB-MaxAB*MaxAB))-1.5;
}
#line 100
float gamma(float grad) { return pow(abs(grad), 2.2); }
#line 107
float3 FilmicSharpenPS(float4 pos : SV_Position, float2 UvCoord : TEXCOORD) : SV_Target
{
#line 110
float3 Source = tex2D(BackBuffer, UvCoord).rgb;
#line 113
float Mask;
if (UseMask)
{
#line 117
Mask = 1.0-length(UvCoord*2.0-1.0);
Mask = Overlay(Mask)*Strength;
#line 120
if (Mask <= 0) return Source;
}
else Mask = Strength;
#line 125
float2 Pixel =  float2((1.0 / 1920), (1.0 / 1080))*Offset;
#line 128
float2 NorSouWesEst[4] = {
float2(UvCoord.x, UvCoord.y+Pixel.y),
float2(UvCoord.x, UvCoord.y-Pixel.y),
float2(UvCoord.x+Pixel.x, UvCoord.y),
float2(UvCoord.x-Pixel.x, UvCoord.y)
};
#line 136
const float3 LumaCoefficient = bool(Coefficient) ? Luma601 : Luma709;
#line 139
float HighPass = 0.0;
[unroll]
for(int i=0; i<4; i++)
HighPass += dot(tex2D(BackBuffer, NorSouWesEst[i]).rgb, LumaCoefficient);
#line 144
HighPass = 0.5-0.5*(HighPass*0.25-dot(Source, LumaCoefficient));
#line 147
HighPass = lerp(0.5, HighPass, Mask);
#line 150
HighPass = Clamp!=1.0? clamp(HighPass, 1.0-Clamp, Clamp) : HighPass;
#line 152
float3 Sharpen = float3(
Overlay(Source.r, HighPass),
Overlay(Source.g, HighPass),
Overlay(Source.b, HighPass)
);
#line 158
return Preview? gamma(HighPass) : Sharpen;
}
#line 166
technique FilmicSharpen < ui_label = "Filmic Sharpen"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = FilmicSharpenPS;
SRGBWriteEnable = true;
}
}

