#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MinimalColorGrading.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MinimalColorGrading.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 10 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MinimalColorGrading.fx"
#line 20
static const float EPSILON = 1e-5;
static const float CONTRAST_LOG_MIDPOINT = 0.18;
#line 27
sampler BackBuffer
{
Texture = ReShade::BackBufferTex;
MinFilter = POINT;
MagFilter = POINT;
MipFilter = POINT;
SRGBTexture = true;
};
#line 58
uniform float Exposure
<
     ui_type = "slider"; 
#line 62
ui_label = "Exposure";
ui_tooltip = "Default: 0.0";
ui_category = "Basic Adjustments";
ui_min = -3.0;
ui_max = 3.0;
> = 0.0;
#line 69
uniform float3 ColorFilter
<
     ui_type = "color"; 
#line 73
ui_label = "Color Filter";
ui_tooltip = "Default: 255 255 255";
ui_category = "Basic Adjustments";
> = float3(1.0, 1.0, 1.0);
#line 78
uniform float Saturation
<
     ui_type = "slider"; 
#line 82
ui_label = "Saturation";
ui_tooltip = "Default: 1.0";
ui_category = "Basic Adjustments";
ui_min = 0.0;
ui_max = 2.0;
> = 1.0;
#line 89
uniform float Contrast
<
     ui_type = "slider"; 
#line 93
ui_label = "Contrast";
ui_tooltip = "Default: 1.0";
ui_category = "Basic Adjustments";
ui_min = 0.0;
ui_max = 2.0;
> = 1.0;
#line 100
uniform int SaturationMode
<
       ui_type = "combo"; 
#line 104
ui_label = "Saturation Mode";
ui_tooltip = "Default: Luma";
ui_items = "Average\0Luminance\0Luma\0Length\0";
> = 2;
#line 109
uniform float2 MousePoint <source="mousepoint";>;
#line 115
float get_grayscale(float3 color)
{
switch (SaturationMode)
{
case 0: 
return dot(color, 0.333);
case 1: 
return max(color.r, max(color.g, color.b));
case 2: 
return dot(color, float3(0.299, 0.587, 0.114));
case 3: 
return exp2(length(log2(color)));
}
#line 129
return 0.0;
}
#line 132
float3 apply_exposure_color(float3 color)
{
return color.rgb * exp2(Exposure) * ColorFilter;
}
#line 137
float3 apply_saturation(float3 color)
{
float gray = get_grayscale(color.rgb);
return gray + (color.rgb - gray) * Saturation;
}
#line 143
float3 apply_contrast(float3 color)
{
color = log2(color + EPSILON);
color = CONTRAST_LOG_MIDPOINT + (color - CONTRAST_LOG_MIDPOINT) * Contrast;
return max(0.0, exp2(color) - EPSILON);
}
#line 165
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
#line 173
float4 color = tex2D(BackBuffer, uv);
#line 177
color.rgb = apply_exposure_color(color.rgb);
color.rgb = apply_saturation(color.rgb);
color.rgb = apply_contrast(color.rgb);
#line 181
return color;
}
#line 188
technique MinimalColorGrading
{
#line 201
pass Main
{
VertexShader = PostProcessVS;
PixelShader = MainPS;
SRGBWriteEnable = true;
}
}

