#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MultiFX.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MultiFX.fx"
#line 40
uniform float3 f3CA_Intensity <
ui_label   = "[Chromatic Aberration] Intensity";
ui_tooltip = "Controls the scale of each color channel in the image. (Red, Green, Blue)";
ui_type    = "drag";
ui_min     = 0.0;
ui_max     = 1.0;
ui_step    = 0.001;
> = 0.0;
#line 49
uniform float fVignette_Intensity <
ui_label = "[Vignette] Opacity";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 3.0;
ui_step  = 0.001;
> = 0.0;
#line 57
uniform float2 f2Vignette_StartEnd <
ui_label   = "[Vignette] Start/End";
ui_tooltip = "Controls the range/contrast of vignette by defining start and end offsets.";
ui_type    = "drag";
ui_min     =-10.0;
ui_max     = 10.0;
ui_step    = 0.001;
> = float2(0.0, 1.0);
#line 66
uniform float fFilmGrain_Intensity <
ui_label = "[Film Grain] Intensity";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 1.0;
ui_step  = 0.001;
> = 0.0;
#line 74
uniform float fFilmGrain_Speed <
ui_label = "[Film Grain] Speed";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 100.0;
ui_step  = 0.001;
> = 1.0;
#line 82
uniform float fFilmGrain_Mean <
ui_label = "[Film Grain] Mean";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 1.0;
ui_step  = 0.001;
> = 0.0;
#line 90
uniform float fFilmGrain_Variance <
ui_label = "[Film Grain] Variance";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 1.0;
ui_step  = 0.001;
> = 0.5;
#line 104
uniform float fSCurve_Intensity <
ui_label = "[S-Curve] Intensity";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 3.0;
ui_step  = 0.001;
> = 0.0;
#line 112
uniform float fTime <source = "timer";>;
#line 118
sampler2D sMultiFX_BackBuffer {
Texture = ReShade::BackBufferTex;
#line 121
SRGBTexture = true;
#line 123
};
#line 127
float2 scale_uv(float2 uv, float2 scale, float2 center) {
return (uv - center) * scale + center;
}
#line 131
float2 scale_uv(float2 uv, float2 scale) {
return scale_uv(uv, scale, 0.5);
}
#line 135
float fmod(float a, float b) {
float c = frac(abs(a / b)) * abs(b);
return (a < 0.0) ? -c : c;
}
#line 140
float rand(float2 uv) {
float a = 12.9898;
float b = 78.233;
float c = 43758.5453;
float dt = dot(uv, float2(a, b));
float sn = fmod(dt, 3.1415);
return frac(sin(sn) * c);
}
#line 149
float3 blend_dodge(float3 a, float3 b, float w) {
return lerp(a, a / max(1.0 - b, 0.0000001), w);
}
#line 153
float gaussian(float z, float u, float o) {
return (1.0 / (o * sqrt(2.0 * 3.1415))) * exp(-(((z - u) * (z - u)) / (2.0 * (o * o))));
}
#line 157
float get_lum(float3 color) {
return max(color.r, max(color.g, color.b));
}
#line 163
void ChromaticAberration(out float4 color, float2 uv) {
color = float4(
tex2D(sMultiFX_BackBuffer, scale_uv(uv, 1.0 - f3CA_Intensity.r * 0.01)).r,
tex2D(sMultiFX_BackBuffer, scale_uv(uv, 1.0 - f3CA_Intensity.g * 0.01)).g,
tex2D(sMultiFX_BackBuffer, scale_uv(uv, 1.0 - f3CA_Intensity.b * 0.01)).b,
1.0
);
}
#line 172
void Vignette(inout float4 color, float2 uv) {
float vignette = 1.0 - smoothstep(
f2Vignette_StartEnd.x,
f2Vignette_StartEnd.y,
distance(uv, 0.5)
);
color = lerp(color, color * vignette, fVignette_Intensity);
}
#line 181
void FilmGrain(inout float4 color, float2 uv) {
float t     = fTime * 0.001 * fFilmGrain_Speed;
float seed  = dot(uv, float2(12.9898, 78.233));
float noise = frac(sin(seed) * 43758.5453 + t);
noise = gaussian(noise, fFilmGrain_Mean, fFilmGrain_Variance * fFilmGrain_Variance);
#line 196
float3 grain = noise * (1.0 - color.rgb);
color.rgb += grain * fFilmGrain_Intensity * 0.01;
#line 200
}
#line 202
void SCurve(inout float4 color, float2 uv) {
color = lerp(color, smoothstep(0.0, 1.0, color), fSCurve_Intensity);
}
#line 208
void PS_MultiFX(
float4 position  : SV_POSITION,
float2 uv        : TEXCOORD,
out float4 color : SV_TARGET
) {
#line 214
ChromaticAberration(color, uv);
#line 219
Vignette(color, uv);
#line 222
FilmGrain(color, uv);
#line 225
SCurve(color, uv);
#line 227
color.a = 1.0;
}
#line 232
technique MultiFX {
pass {
VertexShader = PostProcessVS;
PixelShader = PS_MultiFX;
#line 237
SRGBWriteEnable = true;
#line 239
}
}

