#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Overlay.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Overlay.fx"
#line 19
uniform float fOpacity <
ui_label = "Opacity";
ui_type = "drag";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.001;
> = 1.0;
#line 27
uniform float fStretch <
ui_label = "Stretch";
ui_type = "drag";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.001;
> = 1.0;
#line 35
uniform float2 f2Center <
ui_label = "Center";
ui_type = "drag";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.001;
> = float2(0.5, 0.5);
#line 43
uniform bool bKeepAspectRatio <
ui_label = "Keep Aspect Ratio";
> = false;
#line 47
uniform bool bFollowMouse <
ui_label = "Follow Mouse";
> = false;
#line 51
uniform float2 f2Mouse <source="mousepoint";>;
#line 53
static const float2 f2Resolution = float2( 2560,  1440);
static const float2 f2PixelSize = 1.0 / f2Resolution;
#line 56
texture tOverlay <
source= "Overlay.png";
> {
Width =  2560;
Height =  1440;
};
sampler sOverlay {
Texture = tOverlay;
MinFilter =  LINEAR;
MagFilter =  LINEAR;
AddressU = BORDER;
AddressV = BORDER;
};
#line 70
float2 scale_uv(float2 uv, float2 scale, float2 center) {
return (uv - center) * scale + center;
}
#line 74
float4 PS_Overlay(
float4 pos : SV_POSITION,
float2 uv : TEXCOORD
) : SV_TARGET {
float2 ar = f2Resolution.x > f2Resolution.y ? float2(f2Resolution.x / f2Resolution.y, 1.0) : float2(1.0, f2Resolution.y / f2Resolution.x);
float2 corrected = bKeepAspectRatio ? ReShade::ScreenSize * ar : ReShade::ScreenSize;
float2 stretch = lerp(
ReShade::ScreenSize * f2PixelSize / (bKeepAspectRatio ? 1.0 : ar),
corrected * ReShade::PixelSize,
fStretch
);
#line 86
float2 mouse_pos = saturate(f2Mouse * ReShade::PixelSize);
float2 uv_overlay;
#line 89
if (bFollowMouse)
uv_overlay = scale_uv(
uv - mouse_pos + 0.5,
stretch,
0.5
);
else
uv_overlay = scale_uv(
uv,
stretch,
float2(f2Center.x, 1.0 - f2Center.y)
);
#line 102
float4 original = tex2D(ReShade::BackBuffer, uv);
float4 overlay = tex2D(sOverlay, uv_overlay);
#line 105
float opacity = overlay.a * fOpacity;
#line 107
return lerp(original, overlay, opacity);
}
#line 110
technique Overlay {
pass {
VertexShader = PostProcessVS;
PixelShader = PS_Overlay;
}
}

