#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\PD80\PD80_06_Luma_Fade.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 29 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\PD80\PD80_06_Luma_Fade.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 30 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\PD80\PD80_06_Luma_Fade.fx"
#line 32
namespace pd80_lumafade
{
#line 35
uniform float transition_speed <
ui_type = "slider";
ui_label = "Time Based Fade Speed";
ui_tooltip = "Time Based Fade Speed";
ui_category = "Scene Luminance Adaptation";
ui_min = 0.0f;
ui_max = 1.0f;
> = 0.5;
uniform float minlevel <
ui_label = "Pure Dark Scene Level";
ui_tooltip = "Pure Dark Scene Level";
ui_category = "Scene Luminance Adaptation";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
> = 0.125;
uniform float maxlevel <
ui_label = "Pure Light Scene Level";
ui_tooltip = "Pure Light Scene Level";
ui_category = "Scene Luminance Adaptation";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
> = 0.3;
#line 60
texture texLuma { Width = 256; Height = 256; Format = R16F; MipLevels = 8; };
texture texAvgLuma { Format = R16F; };
texture texPrevAvgLuma { Format = R16F; };
texture texPrevColor { Width = 2560; Height = 1440; Format = RGBA8; };
#line 66
sampler samplerLuma { Texture = texLuma; };
sampler samplerAvgLuma { Texture = texAvgLuma; };
sampler samplerPrevAvgLuma { Texture = texPrevAvgLuma; };
sampler samplerPrevColor { Texture = texPrevColor; };
#line 72
uniform float Frametime < source = "frametime"; >;
#line 75
float interpolate( float o, float n, float factor, float ft )
{
return lerp( o, n, 1.0f - exp( -factor * ft ));
}
#line 81
float PS_WriteLuma(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float4 color     = tex2D( ReShade::BackBuffer, texcoord );
return dot( color.xyz, 0.333333f );
}
#line 87
float PS_AvgLuma(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float luma       = tex2Dlod( samplerLuma, float4( 0.5f, 0.5f, 0, 8 )).x;
float prevluma   = tex2D( samplerPrevAvgLuma, float2( 0.5f, 0.5f )).x;
float factor     = transition_speed * 4.0f + 1.0f;
return interpolate( prevluma, luma, factor, Frametime * 0.001f );
}
#line 95
float4 PS_StorePrev(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
return tex2D( ReShade::BackBuffer, texcoord );
}
#line 100
float PS_PrevAvgLuma(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
return tex2D( samplerAvgLuma, float2( 0.5f, 0.5f )).x;
}
#line 105
float4 PS_LumaInterpolation(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float4 newcol    = tex2D( ReShade::BackBuffer, texcoord );
float4 oldcol    = tex2D( samplerPrevColor, texcoord );
float luma       = tex2D( samplerAvgLuma, float2( 0.5f, 0.5f )).x;
return lerp( oldcol, newcol, smoothstep( minlevel, maxlevel, luma ));
}
#line 114
technique prod80_06_LumaFade_Start
< ui_tooltip = "Luma Fading Effects\n\n"
"This shader allows you to fade in and out ReShade effects based on scene luminance.\n"
"To use: put the Start technque before the shaders you want to enable in a BRIGHT scene and\n"
"put the End technique after those shaders. Then use the UI settings to manipulate the fading.";>
{
pass Luma
{
VertexShader   = PostProcessVS;
PixelShader    = PS_WriteLuma;
RenderTarget   = texLuma;
}
pass AvgLuma
{
VertexShader   = PostProcessVS;
PixelShader    = PS_AvgLuma;
RenderTarget   = texAvgLuma;
}
pass StoreColor
{
VertexShader   = PostProcessVS;
PixelShader    = PS_StorePrev;
RenderTarget   = texPrevColor;
}
pass PreviousLuma
{
VertexShader   = PostProcessVS;
PixelShader    = PS_PrevAvgLuma;
RenderTarget   = texPrevAvgLuma;
}
}
technique prod80_06_LumaFade_End
{
pass Combine
{
VertexShader   = PostProcessVS;
PixelShader    = PS_LumaInterpolation;
}
}
}
