#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\SCurve.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\SCurve.fx"
#line 3
uniform float fCurve <
ui_label = "Curve";
ui_type = "drag";
ui_min = 1.0;
ui_max = 3.0;
ui_step = 0.001;
> = 1.0;
#line 11
uniform float4 f4Offsets <
ui_label = "Offsets";
ui_tooltip = "{ Low Color, High Color, Both, Unused }";
ui_type = "drag";
ui_min = -1.0;
ui_max = 1.0;
ui_step = 0.001;
> = float4(0.0, 0.0, 0.0, 0.0);
#line 20
float4 PS_SCurve(
float4 pos : SV_POSITION,
float2 uv : TEXCOORD
) : SV_TARGET {
float3 col = tex2D(ReShade::BackBuffer, uv).rgb;
float lum = max(col.r, max(col.g, col.b));
#line 29
float3 low = pow(col, fCurve) + f4Offsets.x;
float3 high = pow(col, 1.0 / fCurve) + f4Offsets.y;
#line 32
col.r = lerp(low.r, high.r, col.r + f4Offsets.z);
col.g = lerp(low.g, high.g, col.g + f4Offsets.z);
col.b = lerp(low.b, high.b, col.b + f4Offsets.z);
#line 36
return float4(col, 1.0);
}
#line 39
technique SCurve {
pass {
VertexShader = PostProcessVS;
PixelShader = PS_SCurve;
}
}

