#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Wave.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/Wave.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/RadegastShaders.BlendingModes.fxh"
#line 1
uniform int blending_mode <
ui_type = "combo";
ui_label = "Blending Mode";
ui_items = "Normal\0Add\0Multiply\0Subtract\0Divide\0Darker\0Lighter\0";
ui_tooltip = "Choose a blending mode.";
> = 0;
#line 8
float4 applyBlendingMode(float4 base, float4 color) {
switch(blending_mode) {
case 1:
return color + base;
case 2:
return color * base;
case 3:
return color - base;
case 4:
return color / base;
case 5:
if(length(color.rgb) > length(base.rgb)) return base;
return color;
case 6:
if(length(color.rgb) < length(base.rgb)) return base;
return color;
}
return color;
}
#line 28
float4 applyBlendingMode(float4 base, float4 color, float percent) {
switch(blending_mode) {
case 1:
return lerp(base, color + base, percent);
case 2:
return lerp(base, color * base, percent);
case 3:
return lerp(base, color - base, percent);
case 4:
return lerp(base, color / base, percent);
case 5:
if(length(color.rgb) > length(base.rgb)) return base;
return color;
case 6:
if(length(color.rgb) < length(base.rgb)) return base;
return color;
}
return color;
#line 47
}
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/Wave.fxh"
#line 3
uniform int wave_type <
ui_type = "combo";
ui_label = "Wave Type";
ui_tooltip = "Selects the type of distortion to apply.";
ui_items = "X/X\0X/Y\0";
ui_tooltip = "Which axis the distortion should be performed against.";
> = 1;
#line 11
uniform float angle <
#line 15
ui_type = "slider";
#line 17
ui_label = "Angle";
ui_tooltip = "The angle at which the distortion occurs.";
ui_min = -360.0;
ui_max = 360.0;
ui_step = 1.0;
> = 0.0;
#line 24
uniform float period <
#line 28
ui_type = "slider";
#line 30
ui_label = "Phase";
ui_min = 0.1;
ui_max = 10.0;
ui_tooltip = "The wavelength of the distortion. Smaller values make for a longer wavelength.";
> = 3.0;
#line 36
uniform float amplitude <
#line 40
ui_type = "slider";
#line 42
ui_label = "Amplitude";
ui_min = -1.0;
ui_max = 1.0;
ui_tooltip = "The amplitude of the distortion in each direction.";
> = 0.075;
#line 48
uniform float phase <
#line 52
ui_type = "slider";
#line 54
ui_label = "Phase";
ui_min = -5.0;
ui_max = 5.0;
ui_tooltip = "The offset being applied to the distortion's waves.";
> = 0.0;
#line 60
uniform float min_depth <
#line 64
ui_type = "slider";
#line 66
ui_label="Minimum Depth";
ui_min=0.0;
ui_max=1.0;
> = 0;
#line 71
uniform int animate <
ui_type = "combo";
ui_label = "Animate";
ui_items = "No\0Amplitude\0Phase\0Angle\0";
ui_tooltip = "Enable or disable the animation. Animates the wave effect by phase, amplitude, or angle.";
> = 0;
#line 78
uniform float anim_rate <
source = "timer";
>;
#line 5 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Wave.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Wave.fx"
#line 8
texture texColorBuffer : COLOR;
#line 10
texture waveTarget
{
Width = 2560;
Height = 1440;
MipLevels = LINEAR;
Format = RGBA8;
};
#line 18
sampler samplerColor
{
Texture = texColorBuffer;
#line 22
AddressU = MIRROR;
AddressV = MIRROR;
AddressW = MIRROR;
#line 26
MagFilter = LINEAR;
MinFilter = LINEAR;
MipFilter = LINEAR;
#line 30
MinLOD = 0.0f;
MaxLOD = 1000.0f;
#line 33
MipLODBias = 0.0f;
#line 35
SRGBTexture = false;
};
#line 39
void FullScreenVS(uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD0)
{
if (id == 2)
texcoord.x = 2.0;
else
texcoord.x = 0.0;
#line 46
if (id == 1)
texcoord.y  = 2.0;
else
texcoord.y = 0.0;
#line 51
position = float4( texcoord * float2(2, -2) + float2(-1, 1), 0, 1);
#line 53
}
#line 55
float4 Wave(float4 pos : SV_Position, float2 texcoord : TEXCOORD0) : SV_TARGET
{
const float ar = 1.0 * (float)1440 / (float)2560;
const float2 center = float2(0.5 / ar, 0.5);
const float depth = ReShade::GetLinearizedDepth(texcoord).r;
float2 tc = texcoord;
const float4 base = tex2D(samplerColor, texcoord);
float4 color;
#line 64
tc.x /= ar;
#line 66
const float theta = radians(animate == 3 ? (anim_rate * 0.01 % 360.0) : angle);
const float s =  sin(theta);
const float _s = sin(-theta);
const float c =  cos(theta);
const float _c = cos(-theta);
#line 72
tc = float2(dot(tc - center, float2(c, -s)), dot(tc - center, float2(s, c)));
if(depth >= min_depth){
if(wave_type == 0)
{
switch(animate)
{
default:
tc.x += amplitude * sin((tc.x * period * 10) + phase);
break;
case 1:
tc.x += (sin(anim_rate * 0.001) * amplitude) * sin((tc.x * period * 10) + phase);
break;
case 2:
tc.x += amplitude * sin((tc.x * period * 10) + (anim_rate * 0.001));
break;
}
}
else
{
switch(animate)
{
default:
tc.x +=  amplitude * sin((tc.y * period * 10) + phase);
break;
case 1:
tc.x += (sin(anim_rate * 0.001) * amplitude) * sin((tc.y * period * 10) + phase);
break;
case 2:
tc.x += amplitude * sin((tc.y * period * 10) + (anim_rate * 0.001));
break;
}
}
tc = float2(dot(tc, float2(_c, -_s)), dot(tc, float2(_s, _c))) + center;
#line 106
tc.x *= ar;
#line 108
color = tex2D(samplerColor, tc);
color = applyBlendingMode(base, color);
}
else
{
color = tex2D(samplerColor, texcoord);
}
#line 116
return color;
}
#line 119
technique Wave
{
pass p0
{
VertexShader = FullScreenVS;
PixelShader = Wave;
}
}
