#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ArtisticVignette.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ArtisticVignette.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 4 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ArtisticVignette.fx"
#line 10
static const float Pi = 3.14159;
static const float HalfPi = Pi * 0.5;
#line 13
static const int BlendMode_Mix = 0;
static const int BlendMode_Multiply = 1;
static const int BlendMode_DarkenOnly = 2;
static const int BlendMode_LightenOnly = 3;
static const int BlendMode_Overlay = 4;
static const int BlendMode_Screen = 5;
static const int BlendMode_HardLight = 6;
static const int BlendMode_SoftLight = 7;
#line 22
static const int VignetteShape_None = 0;
static const int VignetteShape_Radial = 1;
static const int VignetteShape_TopBottom = 2;
static const int VignetteShape_LeftRight = 3;
static const int VignetteShape_Box = 4;
static const int VignetteShape_Sky = 5;
static const int VignetteShape_Ground = 6;
#line 34
uniform int _Help
<
ui_text =
"This effect provides a flexible way to create a vignatte overlay.\n"
"\n"
"Specific help for each option can be found by moving the mouse over "
"the option's name.\n"
"\n"
"The appearance can be controlled using a color, with opacity support "
"through the alpha channel, and a blending mode, like Photoshop/GIMP.\n"
"\n"
"Various shapes can be used, with adjustable aspect ratio and gradient "
"points.\n"
;
ui_category = "Help";
ui_category_closed = true;
ui_label = " ";
ui_type = "radio";
>;
#line 54
uniform float4 VignetteColor
<
     ui_type = "color"; 
#line 58
ui_label = "Color";
ui_tooltip =
"Color of the vignette.\n"
"Supports opacity control through the alpha channel.\n"
"\nDefault: 0 0 0 255";
ui_category = "Appearance";
> = float4(0.0, 0.0, 0.0, 1.0);
#line 66
uniform int BlendMode
<
       ui_type = "combo"; 
#line 70
ui_label = "Blending Mode";
ui_tooltip =
"Determines the way the vignette is blended with the image.\n"
"\nDefault: Mix";
ui_category = "Appearance";
ui_items =
"Mix\0Multiply\0Darken Only\0Lighten Only\0Overlay\0Screen\0"
"Hard Light\0Soft Light\0";
> = 0;
#line 80
uniform float2 VignetteStartEnd
<
     ui_type = "drag"; 
#line 84
ui_label = "Start/End";
ui_tooltip =
"The start and end points of the vignette gradient.\n"
"The longer the distance, the smoother the vignette effect is.\n"
"\nDefault: 0.0 1.0";
ui_category = "Shape";
ui_min = 0.0;
ui_max = 3.0;
ui_step = 0.01;
> = float2(0.0, 1.0);
#line 95
uniform float VignetteRatio
<
     ui_type = "slider"; 
#line 99
ui_label = "Ratio";
ui_tooltip =
"The aspect ratio of the vignette.\n"
"0.0: Anamorphic.\n"
"1.0: Corrected.\n"
"\n"
"For example, with 1.0 the radial shape produces a perfect circle.\n"
"\nDefault: 0.0";
ui_category = "Shape";
ui_min = 0.0;
ui_max = 1.0;
> = 0.0;
#line 112
uniform int VignetteShape
<
       ui_type = "combo"; 
#line 116
ui_label = "Shape";
ui_tooltip =
"The shape of the vignette.\n"
"\nDefault: Radial";
ui_category = "Shape";
ui_items = "None\0Radial\0Top/Bottom\0Left/Right\0Box\0Sky\0Ground\0";
> = 1;
#line 128
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(ReShade::BackBuffer, uv);
#line 132
float2 ratio = (ReShade::AspectRatio > 1.0)
? float2(3840 * (1.0 / 2160), 1.0)
: float2(1.0, 2160 * (1.0 / 3840));
float2 ratio_uv = (uv - 0.5) * ratio + 0.5;
#line 137
uv = lerp(uv, ratio_uv, VignetteRatio);
#line 139
float vignette = 1.0;
#line 141
switch (VignetteShape)
{
case VignetteShape_Radial:
vignette = distance(0.5, uv) * HalfPi;
break;
case VignetteShape_TopBottom:
vignette = abs(uv.y - 0.5) * 2.0;
break;
case VignetteShape_LeftRight:
vignette = abs(uv.x - 0.5) * 2.0;
break;
case VignetteShape_Box:
float2 vig = abs(uv - 0.5) * 2.0;
vignette = max(vig.x, vig.y);
break;
case VignetteShape_Sky:
vignette = distance(float2(0.5, 1.0), uv);
break;
case VignetteShape_Ground:
vignette = distance(float2(0.5, 0.0), uv);
break;
}
#line 164
vignette = smoothstep(VignetteStartEnd.x, VignetteStartEnd.y, vignette);
#line 166
float3 vig_color;
#line 168
switch (BlendMode)
{
case BlendMode_Mix:
vig_color = VignetteColor.rgb;
break;
case BlendMode_Multiply:
vig_color = color.rgb * VignetteColor.rgb;
break;
case BlendMode_DarkenOnly:
vig_color = min(color.rgb, VignetteColor.rgb);
break;
case BlendMode_LightenOnly:
vig_color = max(color.rgb, VignetteColor.rgb);
break;
case BlendMode_Overlay:
vig_color = (color.rgb < 0.5)
? 2.0 * color.rgb * VignetteColor.rgb
: 1.0 - 2.0 * (1.0 - color.rgb) * (1.0 - VignetteColor.rgb);
break;
case BlendMode_Screen:
vig_color = 1.0 - (1.0 - color.rgb) * (1.0 - VignetteColor.rgb);
break;
case BlendMode_HardLight:
vig_color = (color.rgb > 0.5)
? 2.0 * color.rgb * VignetteColor.rgb
: 1.0 - 2.0 * (1.0 - color.rgb) * (1.0 - VignetteColor.rgb);
break;
case BlendMode_SoftLight:
vig_color =
(1.0 - 2.0 * VignetteColor.rgb) * (color.rgb * color.rgb) +
2.0 * VignetteColor.rgb * color.rgb;
break;
}
#line 202
color.rgb = lerp(color.rgb, vig_color, vignette * VignetteColor.a);
#line 204
return color;
}
#line 211
technique ArtisticVignette
<
ui_tooltip =
"Flexible vignette overlay effect with multiple shapes and blend modes."
;
>
{
pass
{
VertexShader = PostProcessVS;
PixelShader = MainPS;
}
}

