#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\BeforeAfter.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 15 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\BeforeAfter.fx"
#line 17
uniform bool Line <
> = true;
#line 20
uniform float Offset <
ui_type = "drag";
ui_min = -1.0; ui_max = 1.0; ui_step = 0.001;
> = 0.5;
#line 25
uniform float Blur <
ui_label = "Edge Blur";
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0; ui_step = 0.001;
> = 0.0;
#line 31
uniform float3 Color <      ui_type = "color"; 
ui_label = "Line color";
> = float3(0.337, 0.0, 0.118);
#line 36
texture BeforeTarget { Width = 1920; Height = 1080; };
sampler BeforeSampler { Texture = BeforeTarget; };
#line 45
float Overlay(float LayerAB)
{
float MinAB = min(LayerAB, 0.5);
float MaxAB = max(LayerAB, 0.5);
return 2.0 * (MinAB * MinAB + MaxAB + MaxAB - MaxAB * MaxAB) - 1.5;
}
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 57 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\BeforeAfter.fx"
#line 59
void BeforePS(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 62
Image = tex2D(ReShade::BackBuffer, UvCoord).rgb;
}
#line 65
void AfterPS(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
float Coordinates = Offset < 0.0 ? 1.0 - UvCoord.x : UvCoord.x;
float AbsOffset = abs(Offset);
#line 70
if(Blur == 0.0)
{
bool WhichOne = Coordinates > AbsOffset;
Image = WhichOne ? tex2D(ReShade::BackBuffer, UvCoord).rgb : tex2D(BeforeSampler, UvCoord).rgb;
if(Line) Image = Coordinates < AbsOffset - 0.002 || Coordinates > AbsOffset + 0.002 ? Image : Color;
}
else
{
#line 79
float Mask = clamp((Coordinates - AbsOffset + 0.5 * Blur) / Blur, 0.0, 1.0);
Image = lerp(tex2D(BeforeSampler, UvCoord).rgb, tex2D(ReShade::BackBuffer, UvCoord).rgb, Overlay(Mask));
}
}
#line 89
technique Before < ui_tooltip = "Place this technique before effects you want compare.\nThen move technique 'After'"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = BeforePS;
RenderTarget = BeforeTarget;
}
}
technique After < ui_tooltip = "Place this technique after effects you want compare.\nThen move technique 'Before'"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = AfterPS;
}
}

