#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Flipbook.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 17 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Flipbook.fx"
#line 29
uniform int3 Size <        ui_type = "input"; 
ui_label = "X frames, Y frames, FPS";
ui_tooltip = "Adjust flipbook texture dimensions and framerate\n"
"To change texture resolution and name,\n"
"add following preprocessor definition:\n"
"  flipbook 'name.png'\n"
"  flipbookX [ResolutionX]\n"
"  flipbookY [ResolutionY]";
#line 40
ui_min = 1; ui_max = 30;
ui_category = "Texture dimensions";
> = int3(10, 9, 30);
#line 44
uniform float3 Position <      ui_type = "slider"; 
ui_label = "X position, Y position, Scale";
ui_tooltip = "Adjust flipbook texture size and position";
#line 50
ui_min = float3(0.0, 0.0, 0.1); ui_max = float3(1.0, 1.0, 1.0);
ui_category = "Position on screen";
> = float3(1.0, 0.0, 1.0);
#line 55
uniform float timer < source = "timer"; >;
#line 62
texture FlipbookTex < source =  "waow.png" ; > {Width =  2550 ; Height =  1710 ;};
sampler FlipbookSampler { Texture = FlipbookTex; AddressU = REPEAT; AddressV = REPEAT;};
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 65 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Flipbook.fx"
#line 67
float Mask(float2 Coord)
{
Coord = abs(Coord*2.0-1.0);
float2 Pixel = fwidth(Coord);
float2 Borders = 1.0 - smoothstep(1.0-Pixel, 1.0+Pixel, Coord);
return min(Borders.x, Borders.y);
}
#line 75
float3 FlipbookPS(float4 vois : SV_Position, float2 texcoord : TexCoord) : SV_Target
{
float ScreenAspect = ReShade::AspectRatio;
#line 79
float AspectDifference = (ScreenAspect*float(Size.x* 1710 ))/float(Size.y* 2550 );
#line 82
float2 Scale = 1.0/Position.z;
float2 ScaledCoord = texcoord * Scale;
#line 86
if(AspectDifference > 1.0)
{
ScaledCoord.x *= AspectDifference;
Scale.x *= AspectDifference;
}
else if(AspectDifference < 1.0)
{
ScaledCoord.y /= AspectDifference;
Scale.y /= AspectDifference;
}
#line 98
ScaledCoord += (1.0-Scale)*float2(Position.x, 1.0-Position.y);
#line 100
float BorderMask = Mask(ScaledCoord);
#line 102
float FramerateInMs = 1000.0 / Size.z;
float2 AnimationCoord = ScaledCoord / Size.xy;
#line 105
AnimationCoord.x += frac(floor(timer / FramerateInMs) / Size.x);
AnimationCoord.y += frac(floor( timer / (FramerateInMs * Size.x) )/Size.y);
#line 109
float3 Display = tex2D(ReShade::BackBuffer, texcoord).rgb;
#line 111
float4 AnimationTexture = tex2D(FlipbookSampler, AnimationCoord);
#line 113
return lerp(Display, AnimationTexture.rgb, AnimationTexture.a * BorderMask);
}
#line 121
technique Flipbook < ui_tooltip = "Flipbook animation FX:\n"
"======================\n"
"To change texture resolution and name,\n"
"add following preprocessor definition:\n"
"  flipbook 'name.png'\n"
"  flipbookX [ResolutionX]\n"
"  flipbookY [ResolutionY]"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = FlipbookPS;
}
}

