#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FramerateLimiter.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 10 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FramerateLimiter.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 11 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FramerateLimiter.fx"
#line 17
uniform float Framerate
<
     ui_type = "slider"; 
#line 21
ui_tooltip = "Default: 30.0";
ui_min = 1.0;
ui_max = 144.0;
> = 30.0;
#line 26
uniform float Timer <source = "timer";>;
#line 32
texture LastBackBufferTex { Width = 1920; Height = 1080; };
sampler LastBackBuffer { Texture = LastBackBufferTex; };
#line 35
texture LastTimeTex { Format = R32F; };
sampler LastTime { Texture = LastTimeTex; };
#line 38
texture LastTimeTempTex { Format = R32F; };
sampler LastTimeTemp { Texture = LastTimeTempTex; };
#line 45
bool should_write(sampler LastTime)
{
float last_time = tex2Dfetch(LastTime, 0).x;
float target = rcp(Framerate) * 1000.0;
#line 50
return Timer - last_time > target;
}
#line 57
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
return tex2D(LastBackBuffer, uv);
}
#line 62
float4 SaveLastBackBufferPS(
float4 p: SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
if (should_write(LastTime))
return tex2D(ReShade::BackBuffer, uv);
#line 68
discard;
}
#line 71
float4 CopyLastTimeToTempPS(
float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
return tex2Dfetch(LastTime, 0);
}
#line 77
float4 SaveLastTimePS(float4 p: SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
if (should_write(LastTimeTemp))
return Timer;
#line 82
discard;
}
#line 89
technique FramerateLimiter
{
pass SaveLastBackBuffer
{
VertexShader = PostProcessVS;
PixelShader = SaveLastBackBufferPS;
RenderTarget = LastBackBufferTex;
}
pass CopyLastTimeToTemp
{
VertexShader = PostProcessVS;
PixelShader = CopyLastTimeToTempPS;
RenderTarget = LastTimeTempTex;
}
pass SaveLastTime
{
VertexShader = PostProcessVS;
PixelShader = SaveLastTimePS;
RenderTarget = LastTimeTex;
}
pass Main
{
VertexShader = PostProcessVS;
PixelShader = MainPS;
}
}

