#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MBMB.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 5 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MBMB.fx"
#line 51
uniform float fSensitivity <
ui_label   = "Sensitivity";
ui_tooltip = "This is multiplied to the mouse speed.\n"
"Lower values will help smooth out motion "
"as the mouse speed can be a bit \"jumpy\" "
"at low motions.\n"
"Higher values will instead increase it even "
"more, increasing the overall \"instensity\" "
"of the effect.\n"
"\nDefault: 0.1";
ui_type    = "drag";
ui_min     = 0.0;
ui_max     = 100.0;
ui_step    = 0.01;
> = 0.1;
#line 67
uniform float fDistortion <
ui_label   = "Distortion";
ui_tooltip = "How much to distort the blurring to "
"simulate the look of real vector-based "
"motion blur.\n"
"Can look weird with values too high "
"but also smoothes out the blurring, "
"preventing \"straight lines\".\n"
"\nDefault: 1.0";
ui_type    = "drag";
ui_min     = 0.0;
ui_max     = 10.0;
ui_step    = 0.01;
> = 1.0;
#line 82
uniform float2 f2MinMaxSpeed <
ui_label   = "Min/Max Speed";
ui_tooltip = "The first value tells the shader where "
"to cut off the mouse speed, so it only "
"blurs when you move the mouse at a speed "
"higher than it.\n"
"The second value specifies the maximum "
"speed allowed from the mouse.\n"
"You can disable this by setting the "
"first value to 0.0 and the second to a "
"very high value, like 100.0.\n"
"\nDefault: (0.1, 10.0)";
ui_type    = "drag";
ui_min     = 0.0;
ui_max     = 100.0;
ui_step    = 0.01;
> = float2(0.1, 10.0);
#line 119
uniform float fBlur_Sigma <
ui_label   = "Blur Sigma";
ui_tooltip = "How much to blur the image.\n"
"Too much will reduce the overall "
"quality of the blurring.\n"
"While too little will reduce the "
"amount of blurring overall.\n"
"\nDefault: 4.0";
ui_type    = "drag";
ui_min     = 1.0;
ui_max     = 100.0;
ui_step    = 0.01;
> = 4.0;
#line 160
uniform float3 f3MouseDelta <source = "mousedelta";>;
#line 164
sampler2D sBackBuffer {
Texture     = ReShade::BackBufferTex;
#line 167
MinFilter   = LINEAR;
MagFilter   = LINEAR;
MipFilter   = LINEAR;
AddressU    = CLAMP;
AddressV    = CLAMP;
};
#line 219
float gaussian1D(float x, float sigma) {
return (1.0 / sqrt(2.0 * 3.1415 * (sigma * sigma))) * exp(-((x * x) / (2.0 * (sigma * sigma))));
}
#line 226
float2 clamp_magnitude(float2 v, float2 min_max) {
if (v.x == 0.0 && v.y == 0.0) {
return 0.0;
} else {
float mag = length(v);
return (mag < min_max.x) ? 0.0 : (v / mag) * min(mag, min_max.y);
}
}
#line 235
float3 reinhard(float3 c) {
return c / (1.0 + c);
}
#line 239
float3 inv_reinhard(float3 c, float max_c) {
return (c / max(1.0 - c, max_c));
}
#line 254
float4 PS_MBMB(
float4 position : SV_POSITION,
float2 uv       : TEXCOORD
) : SV_TARGET {
#line 261
float2 speed = f3MouseDelta.xy * fSensitivity;
#line 264
float2 mms = f2MinMaxSpeed;
mms.y = mms.y <= 0.0 ? 10000.0 : mms.y;
speed = clamp_magnitude(speed, mms);
#line 274
float2 ps = ReShade::PixelSize * speed;
#line 276
float d = fDistortion;
#line 282
float2 distort = 1.0 - abs(uv - 0.5) * 2.0;
ps *= lerp(1.0, distort.yx * d, saturate(d));
#line 297
float4 color = 0.0;
#line 301
for (int i = - 20 / 2; i <=  20 / 2; ++i) {
float offset = i;
color += float4(tex2D( sBackBuffer, uv + ps * offset).rgb, 1.0) * gaussian1D(offset, fBlur_Sigma);
}
color.rgb /= color.a;
#line 319
return float4(color.rgb, 1.0);
#line 322
}
#line 345
technique MBMB {
#line 353
pass MBMB {
VertexShader    = PostProcessVS;
PixelShader     = PS_MBMB;
#line 357
}
#line 371
}

