#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\MeshEdges.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 37 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\MeshEdges.fx"
#line 39
uniform int iUIBackground <
ui_type = "combo";
ui_label = "Background Type";
ui_items = "Backbuffer\0Color\0";
> = 1;
#line 45
uniform float3 fUIColorBackground <
ui_type = "color";
ui_label = "Color Background";
> = float3(1.0, 1.0, 1.0);
#line 50
uniform float3 fUIColorLines <
ui_type = "color";
ui_label = "Color Lines";
> = float3(0.0, 0.0, 0.0);
#line 55
uniform float fUIStrength <
ui_type = "drag";
ui_label = "Strength";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.01;
> = 1.0;
#line 67
float3 MeshEdges_PS(float4 vpos:SV_Position, float2 texcoord:TexCoord):SV_Target {
float3 backbuffer = tex2D(ReShade::BackBuffer, texcoord).rgb;
float4 pix = float4(ReShade::PixelSize, -ReShade::PixelSize);
#line 72
float c = ReShade::GetLinearizedDepth(texcoord);
#line 74
float4 depthEven = float4(  ReShade::GetLinearizedDepth(texcoord + float2(0.0, pix.w)),
ReShade::GetLinearizedDepth(texcoord + float2(0.0, pix.y)),
ReShade::GetLinearizedDepth(texcoord + float2(pix.x, 0.0)),
ReShade::GetLinearizedDepth(texcoord + float2(pix.z, 0.0))   );
#line 79
float4 depthOdd  = float4(  ReShade::GetLinearizedDepth(texcoord + float2(pix.x, pix.w)),
ReShade::GetLinearizedDepth(texcoord + float2(pix.z, pix.y)),
ReShade::GetLinearizedDepth(texcoord + float2(pix.x, pix.y)),
ReShade::GetLinearizedDepth(texcoord + float2(pix.z, pix.w)) );
#line 85
float2 mind = float2( min(depthEven.x, min(depthEven.y, min(depthEven.z, depthEven.w))),  min(depthOdd.x, min(depthOdd.y, min(depthOdd.z, depthOdd.w))));
float2 maxd = float2( max(depthEven.x, max(depthEven.y, max(depthEven.z, depthEven.w))),  max(depthOdd.x, max(depthOdd.y, max(depthOdd.z, depthOdd.w))));
float span =  max(maxd.x, maxd.y) -  min(mind.x, mind.y) + 0.00001;
c /= span;
depthEven /= span;
depthOdd /= span;
#line 92
float4 diffsEven = abs(depthEven - c);
float4 diffsOdd = abs(depthOdd - c);
#line 95
float2 retVal = float2( max(abs(diffsEven.x - diffsEven.y), abs(diffsEven.z - diffsEven.w)),
max(abs(diffsOdd.x - diffsOdd.y), abs(diffsOdd.z - diffsOdd.w))     );
#line 98
float lineWeight =  max(retVal.x, retVal.y);
#line 100
return lerp(iUIBackground == 0 ? backbuffer : fUIColorBackground, fUIColorLines, lineWeight * fUIStrength);
}
#line 103
technique MeshEdges {
pass {
VertexShader = PostProcessVS;
PixelShader = MeshEdges_PS;
#line 108
}
}
