#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 4 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\DrawText.fxh"
#line 174
texture Texttex < source = "FontAtlas.png"; > {
Width  = 512;
Height = 512;
};
#line 179
sampler samplerText {
Texture = Texttex;
};
#line 195
float2 DrawText_Shift( float2 pos, int2 shift, float size, float ratio ) {
return pos + size * shift * float2(0.5, 1.0) / ratio;
}
#line 199
void DrawText_Digit( float2 pos, float size, float ratio, float2 tex, int digit, float data, inout float res) {
int digits[13] = {
          16 ,           17 ,           18 ,           19 ,           20 ,           21 ,           22 ,           23 ,           24 ,           25 ,       13 ,        0 ,         14 
};
#line 204
float2 uv = (tex * float2(3840, 2160) - pos) / size;
uv.y      = saturate(uv.y);
uv.x     *= ratio * 2.0;
#line 208
float  t  = abs(data);
int radix = floor(t)? ceil(log2(t)/3.32192809):0;
#line 212
if(uv.x > digit+1 || -uv.x > radix+1) return;
#line 214
float index = t;
if(floor(uv.x) > 0)
for(int i = ceil(-uv.x); i<0; i++) index *= 10.;
else
for(int i = ceil(uv.x); i<0; i++) index /= 10.;
#line 220
index = (uv.x >= -radix-!radix)? index%10 : (10+step(0, data)); 
index = (uv.x > 0 && uv.x < 1)? 12:index; 
index = digits[(uint)index];
#line 224
res  += tex2D(samplerText, (frac(uv) + float2( index % 14.0, trunc(index / 14.0))) /
float2(  14.0,  7.0)).x;
}
#line 5 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3
namespace FXShaders
{
#line 68
static const float Pi = 3.14159;
#line 73
static const float DegreesToRadians = Pi / 180.0;
#line 78
static const float RadiansToDegrees = 180.0 / Pi;
#line 87
float2 GetOffsetByAngleDistance(float2 pos, float angle, float distance)
{
float2 cosSin;
sincos(angle, cosSin.y, cosSin.x);
#line 92
return mad(distance, cosSin, pos);
}
#line 102
float2 GetDirectionFromAngleMagnitude(float angle, float magnitude)
{
return GetOffsetByAngleDistance(0.0, angle, magnitude);
}
#line 114
float2 ClampMagnitude(float2 v, float2 minMax) {
if (v.x == 0.0 && v.y == 0.0)
{
return 0.0;
}
else
{
float mag = length(v);
return (mag < minMax.x) ? 0.0 : (v / mag) * min(mag, minMax.y);
}
}
#line 133
float2 RotatePoint(float2 uv, float angle, float2 pivot)
{
float2 sc;
sincos(DegreesToRadians * angle, sc.x, sc.y);
#line 138
uv -= pivot;
uv = uv.x * sc.yx + float2(-uv.y, uv.y) * sc;
uv += pivot;
#line 142
return uv;
}
#line 145
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 11
namespace FXShaders
{
#line 18
static const float FloatEpsilon = 0.001;
#line 125
float2 GetResolution()
{
return float2(3840, 2160);
}
#line 133
float2 GetPixelSize()
{
return float2((1.0 / 3840), (1.0 / 2160));
}
#line 141
float GetAspectRatio()
{
return 3840 * (1.0 / 2160);
}
#line 149
float4 GetScreenParams()
{
return float4(GetResolution(), GetPixelSize());
}
#line 165
float2 ScaleCoord(float2 uv, float2 scale, float2 pivot)
{
return (uv - pivot) * scale + pivot;
}
#line 178
float2 ScaleCoord(float2 uv, float2 scale)
{
return ScaleCoord(uv, scale, 0.5);
}
#line 188
float GetLumaGamma(float3 color)
{
return dot(color, float3(0.299, 0.587, 0.114));
}
#line 199
float GetLumaLinear(float3 color)
{
return dot(color, float3(0.2126, 0.7152, 0.0722));
}
#line 212
float3 checkered_pattern(float2 uv, float size, float color_a, float color_b)
{
static const float cSize = 32.0;
static const float3 cColorA = pow(0.15, 2.2);
static const float3 cColorB = pow(0.5, 2.2);
#line 218
uv *= GetResolution();
uv %= cSize;
#line 221
float half_size = cSize * 0.5;
float checkered = step(uv.x, half_size) == step(uv.y, half_size);
return (cColorA * checkered) + (cColorB * (1.0 - checkered));
}
#line 232
float3 checkered_pattern(float2 uv)
{
static const float Size = 32.0;
static const float ColorA = pow(0.15, 2.2);
static const float ColorB = pow(0.5, 2.2);
#line 238
return checkered_pattern(uv, Size, ColorA, ColorB);
}
#line 251
float3 ApplySaturation(float3 color, float amount)
{
float gray = GetLumaLinear(color);
return gray + (color - gray) * amount;
}
#line 262
float GetRandom(float2 uv)
{
#line 267
static const float A = 23.2345;
static const float B = 84.1234;
static const float C = 56758.9482;
#line 271
return frac(sin(dot(uv, float2(A, B))) * C);
}
#line 281
void ScreenVS(
uint id : SV_VERTEXID,
out float4 pos : SV_POSITION,
out float2 uv : TEXCOORD)
{
uv.x = (id == 2) ? 2.0 : 0.0;
uv.y = (id == 1) ? 2.0 : 0.0;
#line 289
pos = float4(uv * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 300
float2 CorrectAspectRatio(float2 uv, float a, float b)
{
if (a > b)
{
#line 306
uv = ScaleCoord(uv, float2(1.0 / a, 1.0));
}
else
{
#line 312
uv = ScaleCoord(uv, float2(1.0, 1.0 / b));
}
#line 315
return uv;
}
#line 318
} 
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Canvas.fxh"
#line 9
namespace FXShaders
{
#line 20
void FillRect(inout float4 color, float2 coord, float4 rect, float4 fillColor)
{
if (
coord.x >= rect.x && coord.x <= rect.z &&
coord.y >= rect.y && coord.y <= rect.w)
{
color = fillColor;
}
}
#line 36
float4 ConvertToRect(float2 pos, float2 size)
{
return mad(float2(-0.5, 0.5).xxyy, size.xyxy, pos.xyxy);
}
#line 54
bool AABBCollision(float4 a, float4 b)
{
return
a.x < b.z && b.x < a.z &&
a.y < b.w && b.y < a.w;
}
#line 61
}
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Digits.fxh"
#line 3
namespace FXShaders
{
#line 8
static const int Digit_Space = 0;
static const int Digit_Exclamation = 1;
static const int Digit_DoubleQuote = 2;
static const int Digit_Hash = 3;
static const int Digit_Dollar = 4;
static const int Digit_Percent = 5;
static const int Digit_And = 6;
static const int Digit_SingleQuote = 7;
static const int Digit_OpenParentheses = 8;
static const int Digit_CloseParentheses = 9;
static const int Digit_Asterisk = 10;
static const int Digit_Plus = 11;
static const int Digit_Comma = 12;
static const int Digit_Hyphen = 13;
static const int Digit_Period = 14;
static const int Digit_Slash = 15;
static const int Digit_Zero = 16;
static const int Digit_One = 17;
static const int Digit_Two = 18;
static const int Digit_Three = 19;
static const int Digit_Four = 20;
static const int Digit_Five = 21;
static const int Digit_Six = 22;
static const int Digit_Seven = 23;
static const int Digit_Eight = 24;
static const int Digit_Nine = 25;
static const int Digit_Colon = 26;
static const int Digit_Semicolon = 27;
static const int Digit_LessThan = 28;
static const int Digit_Equals = 29;
static const int Digit_GreaterThan = 30;
static const int Digit_Question = 31;
static const int Digit_At = 32;
static const int Digit_UpperA = 33;
static const int Digit_UpperB = 34;
static const int Digit_UpperC = 35;
static const int Digit_UpperD = 36;
static const int Digit_UpperE = 37;
static const int Digit_UpperF = 38;
static const int Digit_UpperG = 39;
static const int Digit_UpperH = 40;
static const int Digit_UpperI = 41;
static const int Digit_UpperJ = 42;
static const int Digit_UpperK = 43;
static const int Digit_UpperL = 44;
static const int Digit_UpperM = 45;
static const int Digit_UpperN = 46;
static const int Digit_UpperO = 47;
static const int Digit_UpperP = 48;
static const int Digit_UpperQ = 49;
static const int Digit_UpperR = 50;
static const int Digit_UpperS = 51;
static const int Digit_UpperT = 52;
static const int Digit_UpperU = 53;
static const int Digit_UpperV = 54;
static const int Digit_UpperW = 55;
static const int Digit_UpperX = 56;
static const int Digit_UpperY = 57;
static const int Digit_UpperZ = 58;
static const int Digit_OpenSquareBracket = 59;
static const int Digit_Backslash = 60;
static const int Digit_CloseSquareBracket = 61;
static const int Digit_Caret = 62;
static const int Digit_Underscore = 63;
static const int Digit_Backtick = 64;
static const int Digit_LowerA = 65;
static const int Digit_LowerB = 66;
static const int Digit_LowerC = 67;
static const int Digit_LowerD = 68;
static const int Digit_LowerE = 69;
static const int Digit_LowerF = 70;
static const int Digit_LowerG = 71;
static const int Digit_LowerH = 72;
static const int Digit_LowerI = 73;
static const int Digit_LowerJ = 74;
static const int Digit_LowerK = 75;
static const int Digit_LowerL = 76;
static const int Digit_LowerM = 77;
static const int Digit_LowerN = 78;
static const int Digit_LowerO = 79;
static const int Digit_LowerP = 80;
static const int Digit_LowerQ = 81;
static const int Digit_LowerR = 82;
static const int Digit_LowerS = 83;
static const int Digit_LowerT = 84;
static const int Digit_LowerU = 85;
static const int Digit_LowerV = 86;
static const int Digit_LowerW = 87;
static const int Digit_LowerX = 88;
static const int Digit_LowerY = 89;
static const int Digit_LowerZ = 90;
static const int Digit_OpenCurlyBrace = 91;
static const int Digit_VerticalBar = 92;
static const int Digit_CloseCurlyBrace = 93;
static const int Digit_Tilde = 94;
static const int Digit_Block = 95;
#line 107
static const int2 DigitSize = int2(3, 5);
#line 109
static const int DigitPixelCount = DigitSize.x * DigitSize.y;
#line 111
static const int DigitCount = 95;
#line 113
static const int2 DigitMapSize =
int2(DigitSize.x * DigitCount + DigitCount - 1, DigitSize.y);
#line 804
texture DigitMapTex <source = "DigitMap.png";>
{
Width = DigitMapSize.x;
Height = DigitMapSize.y;
Format = R8;
};
#line 811
sampler DigitMap
{
Texture = DigitMapTex;
MinFilter = POINT;
MagFilter = POINT;
MipFilter = POINT;
AddressU = REPEAT;
AddressV = REPEAT;
};
#line 825
float GetDigitPixel(int digit, int2 pos)
{
return tex2Dfetch(DigitMap, int4(pos.x + digit * DigitSize.x + digit, pos.y, 0, 0)).x;
#line 830
}
#line 832
void RenderDigit(
inout float4 color,
float2 coord,
int digit,
int digitScale,
int2 digitOffset,
float4 digitColor)
{
#line 843
int2 arrayPos = coord;
arrayPos /= digitScale;
arrayPos -= digitOffset;
#line 847
if (
arrayPos.x < 0 || arrayPos.x >= DigitSize.x ||
arrayPos.y < 0 || arrayPos.y >= DigitSize.y)
{
return;
}
#line 854
float digitPixel = GetDigitPixel(digit, arrayPos);
color.rgb = lerp(color.rgb, digitColor.rgb, digitPixel * digitColor.a);
color.a = max(color.a, digitColor.a * digitPixel);
}
#line 859
void RenderInteger(
inout float4 color,
float2 coord,
int value,
int digits,
bool zeroFill,
int digitScale,
int2 digitOffset,
float4 digitColor)
{
if (zeroFill)
{
[unroll]
for (int i = digits - 1; i >= 0; --i)
{
RenderDigit(
color,
coord,
Digit_Zero - 1 + value % 10,
digitScale,
digitOffset + int2(i * DigitSize.x + i, 0),
digitColor);
#line 882
value /= 10;
}
}
else
{
[unroll]
for (int i = digits - 1; i >= 0; --i)
{
#line 893
if (value != 0 || i == digits - 1)
RenderDigit(
color,
coord,
Digit_Zero - 1 + value % 10,
digitScale,
digitOffset + int2(i * DigitSize.x + i, 0),
digitColor);
#line 902
value /= 10;
}
}
}
#line 909
}
#line 8 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Pong.fx"
#line 27
namespace FXShaders
{
#line 32
static const float BallInitialYPercent = 0.2;
static const float2 BallSize = 50;
#line 35
static const float BallSpeedIncreasePercent = 1.05;
#line 37
static const float2 PaddleSize = float2(250, 50);
static const float PaddleYPercent = 0.9;
#line 40
static const int Corner_TopLeft = 0;
static const int Corner_TopRight = 1;
static const int Corner_BottomLeft = 2;
static const int Corner_BottomRight = 3;
#line 45
static const int2 EasterSize = 128;
#line 51
uniform float Opacity
<
     ui_type = "slider"; 
#line 55
ui_category = "Appearance";
ui_tooltip =
"Global opacity of the pong game.\n"
"\nDefault: 255";
ui_min = 0.0;
ui_max = 1.0;
> = 1.0;
#line 63
uniform float4 BackgroundColor
<
     ui_type = "color"; 
#line 67
ui_category = "Appearance";
ui_label = "Background Color";
ui_tooltip =
"Color of the pong game background, can be transparent.\n"
"\nDefault: 0 0 0 127";
> = float4(0.0, 0.0, 0.0, 1.0);
#line 74
uniform float4 BallColor
<
     ui_type = "color"; 
#line 78
ui_category = "Appearance";
ui_label = "Ball Color";
ui_tooltip =
"Color of the pong ball, can be transparent.\n"
"\nDefault: 255 0 0 255";
> = float4(1.0, 0.0, 0.0, 1.0);
#line 85
uniform float4 PaddleColor
<
     ui_type = "color"; 
#line 89
ui_category = "Appearance";
ui_label = "Paddle Color";
ui_tooltip =
"Color of the pong paddle, can be transparent.\n"
"\nDefault: 0 0 255 255";
> = float4(0.0, 0.0, 1.0, 1.0);
#line 96
uniform float4 ScoreColor
<
     ui_type = "color"; 
#line 100
ui_category = "Appearance";
ui_label = "Score Color";
ui_tooltip =
"Color of the pong score, can be transparent.\n"
"\nDefault: 0 255 0 255";
> = float4(0.0, 1.0, 0.0, 1.0);
#line 107
uniform float LaunchDelay
<
     ui_type = "drag"; 
#line 111
ui_category = "Gameplay";
ui_label = "Launch Delay";
ui_tooltip =
"Time in seconds before the ball is launched when the game starts or "
"after a game over.\n"
"\nDefault: 1.0";
ui_min = 0.0;
ui_max = 3.0;
ui_step = 0.01;
> = 1.0;
#line 122
uniform float MaxBallSpeed
<
     ui_type = "slider"; 
#line 126
ui_category = "Gameplay";
ui_label = "Max Ball Speed";
ui_tooltip =
"The maximum speed the ball can achieve.\n"
"\nDefault: 3000.0";
ui_min = 1000.0;
ui_max = 10000.0;
> = 3000.0;
#line 135
uniform float RandomSpeed <source = "random"; min = 400; max = 600;>;
uniform float RandomDirection <source = "random"; min = 45; max = 135;>;
#line 138
uniform float2 MousePoint <source = "mousepoint";>;
#line 140
uniform float FrameTime <source = "frametime";>;
#line 143
uniform float Timer <source = "timer";>;
#line 155
 texture GameStateTex { Format = RGBA32F; }; sampler GameState { Texture = GameStateTex; MinFilter = POINT; MagFilter = POINT; MipFilter = POINT; };
 texture LastGameStateTex { Format = RGBA32F; }; sampler LastGameState { Texture = LastGameStateTex; MinFilter = POINT; MagFilter = POINT; MipFilter = POINT; };
#line 158
 texture BallPosSpeedTex { Format = RGBA32F; }; sampler BallPosSpeed { Texture = BallPosSpeedTex; MinFilter = POINT; MagFilter = POINT; MipFilter = POINT; };
 texture LastBallPosSpeedTex { Format = RGBA32F; }; sampler LastBallPosSpeed { Texture = LastBallPosSpeedTex; MinFilter = POINT; MagFilter = POINT; MipFilter = POINT; };
#line 161
texture EasterTex <source = "Pong.png";>
{
Width = EasterSize.x;
Height = EasterSize.y;
};
#line 167
sampler Easter
{
Texture = EasterTex;
AddressU = BORDER;
AddressV = BORDER;
};
#line 178
void RenderBall(inout float4 color, float2 coord, float2 ballPos)
{
float4 rect = ConvertToRect(ballPos, BallSize);
FillRect(color, coord, rect, BallColor);
}
#line 184
float2 GetPaddlePos()
{
float2 paddlePos = float2(MousePoint.x, 2160 * PaddleYPercent);
#line 188
float paddleHalfWidth = PaddleSize.x * 0.5;
paddlePos.x = clamp(
paddlePos.x,
paddleHalfWidth,
3840 - paddleHalfWidth);
#line 194
return paddlePos;
}
#line 197
void RenderPaddle(inout float4 color, float2 coord, float2 paddlePos)
{
float4 rect = ConvertToRect(paddlePos, PaddleSize);
FillRect(color, coord, rect, PaddleColor);
}
#line 203
void RenderScore(inout float4 color, float2 coord, int score)
{
RenderInteger(
color,
coord,
score,
4,
false,
32,
0,
ScoreColor);
}
#line 216
float2 DeobfuscateCoord(float2 coord)
{
if ((coord.y % 2.0) > 1.0)
coord.x = EasterSize.x - coord.x;
#line 221
if ((coord.x % 2.0) > 1.0)
coord.y = EasterSize.y - coord.y;
#line 224
return coord;
}
#line 227
void RenderEaster(inout float4 color, float2 coord, int corner)
{
switch (corner)
{
case Corner_TopLeft:
coord.y -= (Timer * 0.1) % 128 - 128;
coord.y = EasterSize.y - coord.y;
coord = DeobfuscateCoord(coord);
break;
case Corner_TopRight:
coord.x -= 3840 - EasterSize.x;
coord.x = EasterSize.x - coord.x;
coord = DeobfuscateCoord(coord);
coord.y = EasterSize.y - coord.y;
break;
}
#line 244
float4 easter = tex2Dfetch(Easter, int4(coord, 0, 0));
easter.rgb = 1.0 - easter.rgb;
#line 247
color.rgb = lerp(color.rgb, easter.rgb, easter.a);
color.a = max(color.a, easter.a);
}
#line 255
void CalcLogicPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD,
out float4 gameState : SV_TARGET0,
out float4 posSpeed : SV_TARGET1)
{
gameState = tex2Dfetch(LastGameState, 0);
#line 264
if (gameState.x == 0)
{
#line 267
gameState.x = 1;
#line 270
gameState.y = 0;
#line 273
gameState.z = Timer;
#line 276
gameState.w = 0.0;
#line 278
float2 startPos =  float2(3840, 2160) * float2(0.5, BallInitialYPercent);
#line 280
float2 startSpeed = GetDirectionFromAngleMagnitude(
RandomDirection * DegreesToRadians,
RandomSpeed);
#line 284
posSpeed = float4(startPos, startSpeed);
#line 286
return;
}
#line 290
if (Timer - gameState.z < (LaunchDelay * 1000.0))
return;
#line 293
posSpeed = tex2Dfetch(LastBallPosSpeed, 0);
posSpeed.xy += posSpeed.zw *  (FrameTime * 0.001);
#line 297
if (posSpeed.y - BallSize.y > 2160)
{
#line 300
gameState.x = 0;
#line 302
return;
}
#line 305
float2 paddlePos = GetPaddlePos();
#line 307
float4 ballRect = ConvertToRect(posSpeed.xy, BallSize);
float4 paddleRect = ConvertToRect(paddlePos, PaddleSize);
#line 310
if (AABBCollision(ballRect, paddleRect))
{
if (gameState.w < 1.0)
{
float2 delta = posSpeed.xy - paddlePos;
float angle = atan2(delta.y, delta.x);
float speed = length(posSpeed.zw) * BallSpeedIncreasePercent;
#line 318
posSpeed.zw = GetDirectionFromAngleMagnitude(angle, speed);
#line 320
++gameState.y;
gameState.w = 1.0;
}
}
else
{
gameState.w = 0.0;
}
#line 329
if (ballRect.x < 0.0)
posSpeed.z = abs(posSpeed.z);
else if (ballRect.z > 3840)
posSpeed.z = -abs(posSpeed.z);
#line 334
if (ballRect.y < 0.0)
posSpeed.w = abs(posSpeed.w);
#line 337
posSpeed.zw = ClampMagnitude(posSpeed.zw, float2(0.0, MaxBallSpeed));
}
#line 340
void SaveLogicPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD,
out float4 gameState : SV_TARGET0,
out float4 posSpeed : SV_TARGET1)
{
gameState = tex2Dfetch(GameState, 0);
posSpeed = tex2Dfetch(BallPosSpeed, 0);
}
#line 350
float4 RenderPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float2 coord = uv *  float2(3840, 2160);
float4 color = tex2D(ReShade::BackBuffer, uv);
#line 355
float4 gameState = tex2Dfetch(GameState, 0);
float4 posSpeed = tex2Dfetch(BallPosSpeed, 0);
float4 pongGame = BackgroundColor;
#line 359
RenderEaster(pongGame, coord, Corner_TopLeft);
#line 361
RenderBall(pongGame, coord, posSpeed.xy);
#line 363
RenderPaddle(pongGame, coord, GetPaddlePos());
#line 365
RenderScore(pongGame, coord, gameState.y);
#line 367
color.rgb = lerp(color.rgb, pongGame.rgb, pongGame.a * Opacity);
#line 369
return color;
}
#line 376
technique Pong
{
pass CalcLogic
{
VertexShader = PostProcessVS;
PixelShader = CalcLogicPS;
RenderTarget0 = GameStateTex;
RenderTarget1 = BallPosSpeedTex;
}
pass SaveLogic
{
VertexShader = PostProcessVS;
PixelShader = SaveLogicPS;
RenderTarget0 = LastGameStateTex;
RenderTarget1 = LastBallPosSpeedTex;
}
pass Render
{
VertexShader = PostProcessVS;
PixelShader = RenderPS;
}
}
#line 401
} 

