#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\SunsetFilter.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 15 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\SunsetFilter.fx"
#line 17
uniform float3 ColorA <      ui_type = "color"; 
ui_label = "Colour (A)";
ui_category = "Colors";
> = float3(1.0, 0.0, 0.0);
#line 22
uniform float3 ColorB <      ui_type = "color"; 
ui_label = "Colour (B)";
ui_type = "color";
ui_category = "Colors";
> = float3(0.0, 0.0, 0.0);
#line 28
uniform bool Flip <
ui_label = "Color flip";
ui_category = "Colors";
> = false;
#line 33
uniform int Axis <        ui_type = "slider"; 
ui_label = "Angle";
#line 38
ui_min = -180; ui_max = 180;
ui_category = "Controls";
> = -7;
#line 42
uniform float Scale <      ui_type = "slider"; 
ui_label = "Gradient sharpness";
ui_min = 0.5; ui_max = 1.0; ui_step = 0.005;
ui_category = "Controls";
> = 1.0;
#line 48
uniform float Offset <      ui_type = "slider"; 
ui_label = "Position";
#line 53
ui_min = 0.0; ui_max = 0.5;
ui_category = "Controls";
> = 0.0;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 62 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\SunsetFilter.fx"
#line 65
float Overlay(float Layer)
{
float Min = min(Layer, 0.5);
float Max = max(Layer, 0.5);
return 2 * (Min * Min + 2 * Max - Max * Max) - 1.5;
}
#line 73
float3 Screen(float3 LayerA, float3 LayerB)
{ return 1.0 - (1.0 - LayerA) * (1.0 - LayerB); }
#line 81
void SunsetFilterPS(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 84
Image.rgb = tex2D(ReShade::BackBuffer, UvCoord).rgb;
#line 86
float2 UvCoordAspect = UvCoord;
UvCoordAspect.y += ReShade::AspectRatio * 0.5 - 0.5;
UvCoordAspect.y /= ReShade::AspectRatio;
#line 90
UvCoordAspect = UvCoordAspect * 2 - 1;
UvCoordAspect *= Scale;
#line 94
float Angle = radians(-Axis);
float2 TiltVector = float2(sin(Angle), cos(Angle));
#line 98
float BlendMask = dot(TiltVector, UvCoordAspect) + Offset;
BlendMask = Overlay(BlendMask * 0.5 + 0.5); 
#line 102
Image = Screen(Image.rgb, lerp(ColorA.rgb, ColorB.rgb, Flip ? 1 - BlendMask : BlendMask));
}
#line 110
technique SunsetFilter < ui_label = "Sunset Filter"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = SunsetFilterPS;
}
}

