#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\TinyPlanet.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/TinyPlanet.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/RadegastShaders.Transforms.fxh"
#line 1
float2x2 swirlTransform(float theta) {
const float c = cos(theta);
const float s = sin(theta);
#line 5
const float m1 = c;
const float m2 = -s;
const float m3 = s;
const float m4 = c;
#line 10
return float2x2(
m1, m2,
m3, m4
);
};
#line 16
float2x2 zigzagTransform(float theta) {
const float c = cos(theta);
return float2x2(
c, 0,
0, c
);
}
#line 24
float3x3 getrot(float3 r)
{
const float cx = cos(radians(r.x));
const float sx = sin(radians(r.x));
const float cy = cos(radians(r.y));
const float sy = sin(radians(r.y));
const float cz = cos(radians(r.z));
const float sz = sin(radians(r.z));
#line 33
const float m1 = cy * cz;
const float m2= cx * sz + sx * sy * cz;
const float m3= sx * sz - cx * sy * cz;
const float m4= -cy * sz;
const float m5= cx * cz - sx * sy * sz;
const float m6= sx * cz + cx * sy * sz;
const float m7= sy;
const float m8= -sx * cy;
const float m9= cx * cy;
#line 43
return float3x3
(
m1,m2,m3,
m4,m5,m6,
m7,m8,m9
);
};
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/TinyPlanet.fxh"
#line 5
uniform float center_x <
#line 9
ui_type = "slider";
#line 11
ui_label = "X Projection Position";
ui_tooltip = "Adjusts the X coordinate projection of the sphere onto the display. The value is in degrees.";
ui_min = 0.0;
ui_max = 360.0;
> = 0;
#line 17
uniform float center_y <
#line 21
ui_type = "slider";
#line 23
ui_label = "Y Projection Position";
ui_tooltip = "Adjusts the Y coordinate projection of the sphere onto the display. The value is in degrees.";
ui_min = 0.0;
ui_max = 360.0;
> =0;
#line 29
uniform float2 offset <
#line 33
ui_type = "slider";
#line 35
ui_label = "Offset";
ui_tooltip = "Horizontally/Vertically offsets the center of the display by a certain amount.";
ui_min = -.5;
ui_max = .5;
> = 0;
#line 41
uniform float scale <
#line 45
ui_type = "slider";
#line 47
ui_label = "Scale";
ui_tooltip = "Determine's the display's Z-position on the projected sphere. Use this to zoom into or zoom out of the planet if it's too small or big respectively.";
ui_min = 0.0;
ui_max = 10.0;
> = 10.0;
#line 53
uniform float z_rotation <
#line 57
ui_type = "slider";
#line 59
ui_label = "Z-Rotation";
ui_tooltip = "Rotates the display along the z-axis. This can help you orient characters or features on your display the way you want.";
ui_min = 0.0;
ui_max = 360.0;
> = 0.5;
#line 65
uniform float seam_scale <
#line 69
ui_type = "slider";
#line 71
ui_min = 0.5;
ui_max = 1.0;
ui_label = "Seam Blending";
ui_tooltip = "Blends the ends of the screen so that the seam is somewhat reasonably hidden.";
> = 0.5;
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\TinyPlanet.fx"
#line 8
texture texColorBuffer : COLOR;
texture texDepthBuffer : DEPTH;
#line 12
texture TinyPlanetTarget
{
Width = 2560;
Height = 1440;
MipLevels = LINEAR;
Format = RGBA8;
};
#line 21
sampler samplerColor
{
Texture = texColorBuffer;
#line 25
AddressU = WRAP;
AddressV = WRAP;
AddressW = WRAP;
#line 29
MagFilter = LINEAR;
MinFilter = LINEAR;
MipFilter = LINEAR;
#line 33
MinLOD = 0.0f;
MaxLOD = 1000.0f;
#line 36
MipLODBias = 0.0f;
#line 38
SRGBTexture = false;
};
#line 43
void FullScreenVS(uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD0)
{
if (id == 2)
texcoord.x = 2.0;
else
texcoord.x = 0.0;
#line 50
if (id == 1)
texcoord.y  = 2.0;
else
texcoord.y = 0.0;
#line 55
position = float4( texcoord * float2(2, -2) + float2(-1, 1), 0, 1);
}
#line 59
float4 PreTP(float4 pos : SV_Position, float2 texcoord : TEXCOORD0) : SV_TARGET
{
const float inv_seam = 1 - seam_scale;
float4 tc1 =  tex2D(samplerColor, texcoord + float2(inv_seam, 0.0));
float4 tc = tex2D(samplerColor, texcoord * float2(seam_scale, 1.0));
#line 65
if(texcoord.x < inv_seam){
tc.rgb = lerp(tc1.rgb, tc.rgb, 1- clamp((inv_seam-texcoord.x) * 10., 0, 1));
}
if(texcoord.x > seam_scale) tc.rgb = lerp(tc.rgb, tc1.rgb, clamp((texcoord.x-seam_scale) * 10., 0, 1));
return tc;
}
#line 72
float4 TinyPlanet(float4 pos : SV_Position, float2 texcoord : TEXCOORD0) : SV_TARGET
{
const float ar = 1.0 * (float)1440 / (float)2560;
#line 76
const float3x3 rot = getrot(float3(center_x,center_y, z_rotation));
#line 78
const float2 rads = float2( 3.141592358 * 2.0 ,  3.141592358);
const float2 pnt = (texcoord - 0.5 - offset).xy * float2(scale, scale*ar);
#line 82
const float x2y2 = pnt.x * pnt.x + pnt.y * pnt.y;
float3 sphere_pnt = float3(2.0 * pnt, x2y2 - 1.0) / (x2y2 + 1.0);
#line 85
sphere_pnt = mul(sphere_pnt, rot);
#line 88
const float r = length(sphere_pnt);
const float lon = atan2(sphere_pnt.y, sphere_pnt.x);
const float lat = acos(sphere_pnt.z / r);
#line 92
return tex2D(samplerColor, float2(lon, lat) / rads);
}
#line 96
technique TinyPlanet
{
pass p0
{
VertexShader = FullScreenVS;
PixelShader = PreTP;
}
pass p1
{
VertexShader = FullScreenVS;
PixelShader = TinyPlanet;
}
};
