#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\TrackingRays.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3
namespace FXShaders
{
#line 68
static const float Pi = 3.14159;
#line 73
static const float DegreesToRadians = Pi / 180.0;
#line 78
static const float RadiansToDegrees = 180.0 / Pi;
#line 87
float2 GetOffsetByAngleDistance(float2 pos, float angle, float distance)
{
float2 cosSin;
sincos(angle, cosSin.y, cosSin.x);
#line 92
return mad(distance, cosSin, pos);
}
#line 102
float2 GetDirectionFromAngleMagnitude(float angle, float magnitude)
{
return GetOffsetByAngleDistance(0.0, angle, magnitude);
}
#line 114
float2 ClampMagnitude(float2 v, float2 minMax) {
if (v.x == 0.0 && v.y == 0.0)
{
return 0.0;
}
else
{
float mag = length(v);
return (mag < minMax.x) ? 0.0 : (v / mag) * min(mag, minMax.y);
}
}
#line 133
float2 RotatePoint(float2 uv, float angle, float2 pivot)
{
float2 sc;
sincos(DegreesToRadians * angle, sc.x, sc.y);
#line 138
uv -= pivot;
uv = uv.x * sc.yx + float2(-uv.y, uv.y) * sc;
uv += pivot;
#line 142
return uv;
}
#line 145
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 11
namespace FXShaders
{
#line 18
static const float FloatEpsilon = 0.001;
#line 125
float2 GetResolution()
{
return float2(3840, 2160);
}
#line 133
float2 GetPixelSize()
{
return float2((1.0 / 3840), (1.0 / 2160));
}
#line 141
float GetAspectRatio()
{
return 3840 * (1.0 / 2160);
}
#line 149
float4 GetScreenParams()
{
return float4(GetResolution(), GetPixelSize());
}
#line 165
float2 ScaleCoord(float2 uv, float2 scale, float2 pivot)
{
return (uv - pivot) * scale + pivot;
}
#line 178
float2 ScaleCoord(float2 uv, float2 scale)
{
return ScaleCoord(uv, scale, 0.5);
}
#line 188
float GetLumaGamma(float3 color)
{
return dot(color, float3(0.299, 0.587, 0.114));
}
#line 199
float GetLumaLinear(float3 color)
{
return dot(color, float3(0.2126, 0.7152, 0.0722));
}
#line 212
float3 checkered_pattern(float2 uv, float size, float color_a, float color_b)
{
static const float cSize = 32.0;
static const float3 cColorA = pow(0.15, 2.2);
static const float3 cColorB = pow(0.5, 2.2);
#line 218
uv *= GetResolution();
uv %= cSize;
#line 221
float half_size = cSize * 0.5;
float checkered = step(uv.x, half_size) == step(uv.y, half_size);
return (cColorA * checkered) + (cColorB * (1.0 - checkered));
}
#line 232
float3 checkered_pattern(float2 uv)
{
static const float Size = 32.0;
static const float ColorA = pow(0.15, 2.2);
static const float ColorB = pow(0.5, 2.2);
#line 238
return checkered_pattern(uv, Size, ColorA, ColorB);
}
#line 251
float3 ApplySaturation(float3 color, float amount)
{
float gray = GetLumaLinear(color);
return gray + (color - gray) * amount;
}
#line 262
float GetRandom(float2 uv)
{
#line 267
static const float A = 23.2345;
static const float B = 84.1234;
static const float C = 56758.9482;
#line 271
return frac(sin(dot(uv, float2(A, B))) * C);
}
#line 281
void ScreenVS(
uint id : SV_VERTEXID,
out float4 pos : SV_POSITION,
out float2 uv : TEXCOORD)
{
uv.x = (id == 2) ? 2.0 : 0.0;
uv.y = (id == 1) ? 2.0 : 0.0;
#line 289
pos = float4(uv * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 300
float2 CorrectAspectRatio(float2 uv, float a, float b)
{
if (a > b)
{
#line 306
uv = ScaleCoord(uv, float2(1.0 / a, 1.0));
}
else
{
#line 312
uv = ScaleCoord(uv, float2(1.0, 1.0 / b));
}
#line 315
return uv;
}
#line 318
} 
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\TrackingRays.fx"
#line 15
namespace FXShaders
{
#line 20
static const int Samples =  13;
static const int TrackPass0Size = 16;
#line 27
  uniform int _WipWarn < ui_text = "This effect is currently a work in progress and as such some " "aspects may change in the future and some features may still be " "missing or incomplete.\n"; ui_label = " "; ui_type = "radio"; >;
#line 29
uniform float Intensity
<
ui_label = "Intensity";
ui_tooltip = "Default: 1.0";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.05;
> = 1.0;
#line 39
uniform float Curve
<
ui_label = "Curve";
ui_tooltip = "Default: 3.0";
ui_type = "slider";
ui_min = 1.0;
ui_max = 5.0;
ui_step = 0.1;
> = 3.0;
#line 49
uniform float Scale
<
ui_label = "Scale";
ui_tooltip = "Default: 10.0";
ui_type = "slider";
ui_min = 1.0;
ui_max = 10.0;
ui_step = 0.1;
> = 10.0;
#line 59
uniform float Delay
<
ui_label = "Delay";
ui_tooltip = "Default: 1.0";
ui_type = "slider";
ui_min = 0.0;
ui_max = 10.0;
ui_step = 0.1;
> = 1.0;
#line 69
uniform float MergeTolerance
<
ui_label = "Merge Tolerance";
ui_tooltip = "Default: 0.1";
ui_type = "slider";
ui_min = 0.0;
ui_max = 0.3;
ui_step = 0.01;
> = 0.1;
#line 79
uniform float FrameTime <source = "frametime";>;
#line 85
texture BackBufferTex : COLOR;
#line 87
sampler BackBuffer
{
Texture = BackBufferTex;
SRGBTexture = true;
};
#line 93
texture CoarseTex
{
Width = TrackPass0Size;
Height = TrackPass0Size;
Format = R8;
};
#line 100
sampler Coarse
{
Texture = CoarseTex;
};
#line 105
texture PivotTex
{
Format = RG16F;
};
#line 110
sampler Pivot
{
Texture = PivotTex;
};
#line 115
texture LastPivotTex
{
Format = RG16F;
};
#line 120
sampler LastPivot
{
Texture = LastPivotTex;
};
#line 129
float4 ZoomBlur(sampler sp, float2 uv, float2 pivot, float scale, int samples)
{
float invScale = rcp(scale);
float4 color = tex2D(sp, uv);
#line 135
[unroll]
for (int i = 1; i < samples; ++i)
{
uv = ScaleCoord(uv, invScale, pivot);
#line 140
float4 pixel = tex2D(sp, uv);
color += pixel;
#line 143
}
#line 145
color /= samples;
#line 148
return color;
}
#line 155
float4 GetCoarsePS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
return tex2D(BackBuffer, uv);
}
#line 160
float4 TrackPass0PS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float2 pivot = 0.5;
float bright = 0.0;
#line 165
[unroll]
for (int x = 0; x < TrackPass0Size; ++x)
{
[unroll]
for (int y = 0; y < TrackPass0Size; ++y)
{
float2 pos = float2(x, y) / TrackPass0Size;
float pixel = tex2D(Coarse, pos).x;
#line 174
if (abs(pixel - bright) < MergeTolerance)
{
bright = (bright + pixel) * 0.5;
pivot = (pivot + pos) * 0.5;
}
else if (pixel > bright)
{
pivot = pos;
bright = pixel;
}
}
}
#line 187
if (Delay > 0.0)
{
float dt = FrameTime * 0.001;
float2 last = tex2Dfetch(LastPivot, 0).xy;
pivot = lerp(last, pivot, saturate(dt / Delay));
}
#line 194
return float4(pivot, 0.0, 1.0);
}
#line 197
float4 SavePivotPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
return tex2Dfetch(Pivot, 0);
}
#line 202
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(BackBuffer, uv);
#line 206
float2 pivot = tex2Dfetch(Pivot, 0).xy;
#line 208
float scale = 1.0 + (Scale - 1.0) / Samples * 0.1;
#line 210
float4 rays = ZoomBlur(BackBuffer, uv, pivot, scale, Samples);
rays.rgb = pow(abs(rays.rgb), Curve);
#line 213
color = 1.0 - (1.0 - color) * (1.0 - rays * Intensity);
#line 215
return color;
}
#line 222
technique TrackingRays
<
ui_tooltip =
"FXShaders - Experimental sun rays effect that tracks brightness in "
"the image.";
>
{
pass GetCoarse
{
VertexShader = ScreenVS;
PixelShader = GetCoarsePS;
RenderTarget = CoarseTex;
}
pass TrackPass0
{
VertexShader = ScreenVS;
PixelShader = TrackPass0PS;
RenderTarget = PivotTex;
}
pass SavePivot
{
VertexShader = ScreenVS;
PixelShader = SavePivotPS;
RenderTarget = LastPivotTex;
}
pass Main
{
VertexShader = ScreenVS;
PixelShader = MainPS;
SRGBWriteEnable = true;
}
}
#line 257
} 

