#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Unsharp.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Blending.fxh"
#line 3
namespace FXShaders
{
#line 14
float3 BlendScreen(float3 a, float3 b, float w)
{
return 1.0 - (1.0 - a) * (1.0 - b * w);
}
#line 27
float3 BlendOverlay(float3 a, float3 b, float w)
{
float3 color = (a < 0.5)
? 2.0 * a * b
: 1.0 - 2.0 * (1.0 - a) * (1.0 - b);
#line 33
return lerp(a, color, w);
}
#line 44
float3 BlendSoftLight(float3 a, float3 b, float w)
{
float3 color = (1.0 - 2.0 * b) * (a * a) + 2.0 * b * a;
#line 48
return lerp(a, color, w);
}
#line 59
float3 BlendHardLight(float3 a, float3 b, float w)
{
float3 color = (a > 0.5)
? 2.0 * a * b
: 1.0 - 2.0 * (1.0 - a) * (1.0 - b);
#line 65
return lerp(a, color, w);
}
#line 68
}
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Unsharp.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3
namespace FXShaders
{
#line 68
static const float Pi = 3.14159;
#line 73
static const float DegreesToRadians = Pi / 180.0;
#line 78
static const float RadiansToDegrees = 180.0 / Pi;
#line 87
float2 GetOffsetByAngleDistance(float2 pos, float angle, float distance)
{
float2 cosSin;
sincos(angle, cosSin.y, cosSin.x);
#line 92
return mad(distance, cosSin, pos);
}
#line 102
float2 GetDirectionFromAngleMagnitude(float angle, float magnitude)
{
return GetOffsetByAngleDistance(0.0, angle, magnitude);
}
#line 114
float2 ClampMagnitude(float2 v, float2 minMax) {
if (v.x == 0.0 && v.y == 0.0)
{
return 0.0;
}
else
{
float mag = length(v);
return (mag < minMax.x) ? 0.0 : (v / mag) * min(mag, minMax.y);
}
}
#line 133
float2 RotatePoint(float2 uv, float angle, float2 pivot)
{
float2 sc;
sincos(DegreesToRadians * angle, sc.x, sc.y);
#line 138
uv -= pivot;
uv = uv.x * sc.yx + float2(-uv.y, uv.y) * sc;
uv += pivot;
#line 142
return uv;
}
#line 145
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 11
namespace FXShaders
{
#line 18
static const float FloatEpsilon = 0.001;
#line 125
float2 GetResolution()
{
return float2(1920, 1080);
}
#line 133
float2 GetPixelSize()
{
return float2((1.0 / 1920), (1.0 / 1080));
}
#line 141
float GetAspectRatio()
{
return 1920 * (1.0 / 1080);
}
#line 149
float4 GetScreenParams()
{
return float4(GetResolution(), GetPixelSize());
}
#line 165
float2 ScaleCoord(float2 uv, float2 scale, float2 pivot)
{
return (uv - pivot) * scale + pivot;
}
#line 178
float2 ScaleCoord(float2 uv, float2 scale)
{
return ScaleCoord(uv, scale, 0.5);
}
#line 188
float GetLumaGamma(float3 color)
{
return dot(color, float3(0.299, 0.587, 0.114));
}
#line 199
float GetLumaLinear(float3 color)
{
return dot(color, float3(0.2126, 0.7152, 0.0722));
}
#line 212
float3 checkered_pattern(float2 uv, float size, float color_a, float color_b)
{
static const float cSize = 32.0;
static const float3 cColorA = pow(0.15, 2.2);
static const float3 cColorB = pow(0.5, 2.2);
#line 218
uv *= GetResolution();
uv %= cSize;
#line 221
float half_size = cSize * 0.5;
float checkered = step(uv.x, half_size) == step(uv.y, half_size);
return (cColorA * checkered) + (cColorB * (1.0 - checkered));
}
#line 232
float3 checkered_pattern(float2 uv)
{
static const float Size = 32.0;
static const float ColorA = pow(0.15, 2.2);
static const float ColorB = pow(0.5, 2.2);
#line 238
return checkered_pattern(uv, Size, ColorA, ColorB);
}
#line 251
float3 ApplySaturation(float3 color, float amount)
{
float gray = GetLumaLinear(color);
return gray + (color - gray) * amount;
}
#line 262
float GetRandom(float2 uv)
{
#line 267
static const float A = 23.2345;
static const float B = 84.1234;
static const float C = 56758.9482;
#line 271
return frac(sin(dot(uv, float2(A, B))) * C);
}
#line 281
void ScreenVS(
uint id : SV_VERTEXID,
out float4 pos : SV_POSITION,
out float2 uv : TEXCOORD)
{
uv.x = (id == 2) ? 2.0 : 0.0;
uv.y = (id == 1) ? 2.0 : 0.0;
#line 289
pos = float4(uv * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 300
float2 CorrectAspectRatio(float2 uv, float a, float b)
{
if (a > b)
{
#line 306
uv = ScaleCoord(uv, float2(1.0 / a, 1.0));
}
else
{
#line 312
uv = ScaleCoord(uv, float2(1.0, 1.0 / b));
}
#line 315
return uv;
}
#line 318
} 
#line 2 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Unsharp.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Convolution.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Convolution.fxh"
#line 5
namespace FXShaders
{
#line 18
float NormalDistribution(float x, float u, float o)
{
o *= o;
#line 22
float a = 1.0 / sqrt(2.0 * Pi * o);
float b = x - u;
b *= b;
b /= 2.0 * o;
#line 27
return a * exp(-(b));
}
#line 38
float Gaussian1D(float x, float o)
{
o *= o;
float a = 1.0 / sqrt(2.0 * Pi * o);
float b = (x * x) / (2.0 * o);
return a * exp(-b);
}
#line 55
float Gaussian1DFast(float x, float o)
{
#line 59
return exp(-(x * x) / (2.0 * o * o));
}
#line 70
float Gaussian2D(float2 i, float o)
{
o *= o;
float a = 1.0 / (2.0 * Pi * o);
float b = (i.x * i.x + i.y * i.y) / (2.0 * o);
return a * exp(-b);
}
#line 91
float4 GaussianBlur1D(
sampler sp,
float2 uv,
float2 dir,
float sigma,
int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
#line 100
float4 color = 0.0;
float accum = 0.0;
#line 103
uv -= halfSamples * dir;
#line 105
[unroll]
for (int i = 0; i < samples; ++i)
{
float weight = Gaussian1DFast(i - halfSamples, sigma);
#line 110
color += tex2D(sp, uv) * weight;
accum += weight;
#line 113
uv += dir;
}
#line 116
return color / accum;
}
#line 132
float4 GaussianBlur2D(
sampler sp,
float2 uv,
float2 scale,
float sigma,
int2 samples)
{
static const float2 halfSamples = samples * 0.5;
#line 141
float4 color = 0.0;
float accum = 0.0;
#line 144
uv -= halfSamples * scale;
#line 146
[unroll]
for (int x = 0; x < samples.x; ++x)
{
float initX = uv.x;
#line 151
[unroll]
for (int y = 0; y < samples.y; ++y)
{
float2 pos = float2(x, y);
float weight = Gaussian2D(abs(pos - halfSamples), sigma);
#line 157
color += tex2D(sp, uv) * weight;
accum += weight;
#line 160
uv.x += scale.x;
}
#line 163
uv.x = initX;
uv.y += scale.y;
}
#line 167
return color / accum;
}
#line 170
float4 LinearBlur1D(sampler sp, float2 uv, float2 dir, int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
uv -= halfSamples * dir;
#line 175
float4 color = 0.0;
#line 177
[unroll]
for (int i = 0; i < samples; ++i)
{
color += tex2D(sp, uv);
uv += dir;
}
#line 184
return color / samples;
}
#line 187
float4 MaxBlur1D(sampler sp, float2 uv, float2 dir, int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
uv -= halfSamples * dir;
#line 192
float4 color = 0.0;
#line 194
[unroll]
for (int i = 0; i < samples; ++i)
{
color = max(color, tex2D(sp, uv));
uv += dir;
}
#line 201
return color;
}
#line 204
float4 SharpBlur1D(sampler sp, float2 uv, float2 dir, int samples, float sharpness)
{
static const float halfSamples = (samples - 1) * 0.5;
static const float weight = 1.0 / samples;
#line 209
uv -= halfSamples * dir;
#line 211
float4 color = 0.0;
#line 213
[unroll]
for (int i = 0; i < samples; ++i)
{
float4 pixel = tex2D(sp, uv);
color = lerp(color + pixel * weight, max(color, pixel), sharpness);
uv += dir;
}
#line 221
return color;
}
#line 224
} 
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Unsharp.fx"
#line 9
namespace FXShaders
{
#line 12
static const int BlurSamples =  21;
#line 14
uniform float Amount
<
ui_category = "Appearance";
ui_label = "Amount";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
> = 1.0;
#line 23
uniform float BlurScale
<
ui_category = "Appearance";
ui_label = "Blur Scale";
ui_type = "slider";
ui_min = 0.01;
ui_max = 1.0;
> = 1.0;
#line 32
texture ColorTex : COLOR;
#line 34
sampler ColorSRGB
{
Texture = ColorTex;
#line 38
};
#line 40
sampler ColorLinear
{
Texture = ColorTex;
};
#line 45
texture OriginalTex
{
Width = 1920;
Height = 1080;
#line 53
};
#line 55
sampler Original
{
Texture = OriginalTex;
MinFilter = POINT;
MagFilter = POINT;
MipFilter = POINT;
};
#line 63
float4 Blur(sampler tex, float2 uv, float2 dir)
{
float4 color = GaussianBlur1D(
tex,
uv,
dir * GetPixelSize() * 3.0,
sqrt(BlurSamples) * BlurScale,
BlurSamples
);
#line 74
color += abs(GetRandom(uv) - 0.5) * FloatEpsilon * 25.0;
#line 76
return color;
}
#line 79
float4 CopyOriginalPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(ColorSRGB, uv);
#line 83
return color;
}
#line 94
 float4 Blur0PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(ColorSRGB, uv, float2(1.0, 0.0)); };
#line 96
 float4 Blur1PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(ColorLinear, uv, float2(0.0, 4.0)); };
#line 98
 float4 Blur2PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(ColorLinear, uv, float2(4.0, 0.0)); };
#line 100
 float4 Blur3PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(ColorLinear, uv, float2(0.0, 1.0)); };
#line 102
float4 BlendPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(Original, uv);
#line 106
float4 blur = tex2D(ColorLinear, uv);
float mask = GetLumaGamma(1.0 - blur.rgb);
mask *= 0.75;
#line 110
color.rgb = BlendOverlay(color.rgb, mask, Amount);
#line 112
return color;
}
#line 115
technique Unsharp
{
pass CopyOriginal
{
VertexShader = ScreenVS;
PixelShader = CopyOriginalPS;
RenderTarget = OriginalTex;
}
pass Blur0
{
VertexShader = ScreenVS;
PixelShader = Blur0PS;
}
pass Blur1
{
VertexShader = ScreenVS;
PixelShader = Blur1PS;
}
pass Blur2
{
VertexShader = ScreenVS;
PixelShader = Blur2PS;
}
pass Blur3
{
VertexShader = ScreenVS;
PixelShader = Blur3PS;
}
pass Blend
{
VertexShader = ScreenVS;
PixelShader = BlendPS;
#line 148
}
}
#line 151
}

